<?php

  /**************************************************************************\
  * imagemod.php    Modifies image metadata of existing images.              *
  ***************************************************************************
  * This script modifies image meta data. It calls functions in              *
  *  image_inc.php to do the dirty work                                      *
  *                                                                          *
  ****************************************************************************
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000,2001 by Nico Stuurman                                 *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/ 


require("include.php");
require ($include_dir."/image_inc.php");


// generate string $args to pass all useful values from search.php to other 
// scripts (and receive them back)
 
$arg_string = "action,number_of_visible_results,loginname,trust,audit,";
$arg_string .= "file_name,file_id,des_cription,period_nr,period,";
$arg_string .= "date_comparison,date_day,date_month,date_year,keybool,period,";
$arg_string .= "period_nr,serial_selarray,restart,";

$get_vars = $arg_string ."keywrds,imageid,";

globalize_vars ($get_vars,"HTTP_GET_VARS");


$post_vars = "modify,";
$post_vars .= "mime,resubmit,filetype,description,x_thumb,y_thumb,";
$post_vars .= "fs,raw_data,keys,viewrights,trust_array,";
$post_vars .= "x_nm,y_nm,z_nm,t_sec,scope,refrinxlensmedium,numaperture,";
$post_vars .= "refrinxmedium,exp_date_text,exp_date_box,";
$post_vars .= "channel,nr_channels,channel_up,";

globalize_vars ($post_vars, "HTTP_POST_VARS");

$PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];

$args = make_args ($arg_string);
 
if ($keywrds) {
   $keywrds = stripslashes ($keywrds);
   $keywrds = urlencode ($keywrds);
   $args .= "&"."keywrds=". $keywrds;
}                                   


$title = "Modify Image meta-data";
printheader();

if(imgrights($imageid)) { 
   // when called from submit button write meta-data and show (modified) image 
   if ($modify) {

      upload_database (true);

      if ($restart) $args.= "&"."restart=$restart";
         echo "<br><br><a href=\"search.php?".$args.
               "\" align='right'>Back to images</a><br>";
      
      $id = $imageid;
      echo "<TABLE>";
      // we need to unset all variables set as POSTVARS to avoid interfering w
      // with search query.  Bad design with all those globals....
      if ($HTTP_POST_VARS["trust_array"]) {
         unset($trust);
      }
      reset($HTTP_POST_VARS);
      while (list($key,$value)=each($HTTP_POST_VARS)) {
         unset (${$key});
      }
      include ("$include_dir/show_inc.php");
      echo "</TABLE>\n";

      if ($restart) $args.= "&"."restart=$restart";
         echo "<br><br><a href=\"search.php?".$args."\">Back to images</a>";
   }

   else {  // show the form in which modifications can be made 
  
      echo "<FORM ENCTYPE=\"multipart/form-data\" METHOD=\"post\" 
            ACTION=\"$PHP_SELF?imageid=$imageid"."$args\">\n";
      echo "<TABLE BORDER = 0>\n";
      
/************* when shown for first time, pull data from database *******/         

      // image information is put into a table
      $query = "SELECT $image_fields FROM images WHERE imageid = '$imageid';";
      $result = db_exec($query);
      $numberofcols = db_numfields($result);

      $value = db_fetch_array($result,0);
      $filetype = $value["filetype"];
      $filename = $value["filename"];

      if (!($resubmit) ) {
         // make all image meta data known globally, 
                // so that show_image_form will know them
         for ($i = 0 ; $i <$numberofcols; $i++) {
            $fieldname = db_fieldname($result, $i);
            global $$fieldname;
            $$fieldname = $value[$fieldname];
            $test = $$fieldname;
         }
      
         // let keywords be known
         global $keys;
         $keys = get_keywordid ($imageid);      
      }

      // display imagename
      echo "<TR><TD>".translate("filename"). "</TD><TD>$filename</TD></TR>\n";

      // and mime type
      echo "<TR><TD> mime type:</TD>\n";
      echo "<TD><INPUT TYPE='TEXT', NAME='mime', VALUE='$mime', 
             tabindex=50></TD></TR>\n"; 

      // and the rest of the table
      show_image_form ($filetype, "modify", $image_fields, 0);


      echo "<TR><TD></TD><TD ALIGN=\"right\"><INPUT TYPE=\"submit\" 
            NAME=\"modify\" VALUE=\"modify image data\">";
      echo "</TABLE>";
      echo "</FORM>";

   }
}

else  // if(imgrights($imageid)): 
   echo "You do not have the rights to modify the meta data of this image";

printfooter();

?>
