<?php

// image_inc.php - Displays form for image meta-data
// image_inc.php - author: Nico Stuurman 
  /***************************************************************************
  * Contains a function related to management of image metadata              *
  * Main body produces a form                                                *
  * Called by upload.php and imagemod.php                                    *
  *                                                                          *
  ***************************************************************************
  *             FUNCTIONS                                                    *
  * show_image_form ($filetype, $new_modify, $image_fields, $templateid)     * 
  * upload_database ($do_modify = false)                                     * 
  **************************************************************************
  * Created 10-3-00 by Nico                                                  *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Last modified 12/17/00                                                   *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                              


$image_fields = "imageid,userid,filename,description,private,";
$image_fields .= "restrict_to_group,everyone,raw_data,";
$image_fields .= "trust,microscope_type,filesize,filetype,";
$image_fields .= "filetype_extension,channels,exp_date,md5sum,";
$image_fields .= "refrinxmedium,refrinxlensmedium,numaperture,date_time,";
$image_fields .= "x_nm,y_nm,z_nm,t_sec,x_thumb,y_thumb,fs_thumb,mime";

////
// !produces part of form, initiated by upload.php and imagemod.php
function show_image_form ($filetype, $new_modify, $image_fields, $templateid) {
   global $S_USERID, $resubmit, $scope, $fs, $trust_array, $viewrights; 
   global $nr_channels, $keys, $exp_date_text, $exp_date_box, $projects;

/************************ initialize *******************************/

   // check for template and get those data into $template_values
   if ($templateid > 0 && !$resubmit) {
      // get template info from database
      $query = "SELECT * FROM template WHERE templateid = '$templateid' 
                AND userid = '$S_USERID';";
      $result = db_exec($query);
      $numberofcols = db_numfields($result);
      $template_values = db_fetch_array($result,0);
      $keys = get_keywordid_template ($templateid);
      $projectid = get_project ($templateid, "template");
   }

   // 'read' in all global image meta-data, wherever they come from
   $fieldname = trim(strtok ($image_fields,","));
   global $$fieldname;
   if (!($resubmit) && $template_values)
         $$fieldname = $template_values[$fieldname];
   while ($fieldname) {
      $fieldname = trim(strtok (","));
      global $$fieldname;
      if (!($resubmit) && $template_values[$fieldname])
         $$fieldname = $template_values[$fieldname];
   }
   if ($imageid && !$projectid)
      $projectid = get_project ($imageid, "images");
   if (!$trust_array && $imageid)
      $trust_array=get_trust_array($imageid);
      
   // deal with exp_period (in template) versus exp_date
   if ($template_values["exp_period"])
      $exp_date = time () + $template_values["exp_period"];  
    
   if ($resubmit) {
      // get microscope type from form input
      $microscope_type = get_array_value ($scope);
      // determine selected frame rate
      $fs_thumb = get_array_value ($fs);
      // determine selected project
      $projectid = $projects;

      // determine expiration date
      if ($exp_date_box)
         $exp_date = 0;
      else 
         $exp_date = get_unix_time ($exp_date_text);

      // determine trusted users
      $trust = last_array_value ($trust_array);
   }

   $description = stripslashes ($description);

/********************** start display form *************************/

   // hidden variable to detect resubmissions
   echo "<INPUT TYPE='hidden' NAME='resubmit' VALUE='true'>\n";
   echo "<INPUT TYPE ='hidden' NAME='filetype' VALUE='$filetype'>\n";

   //Textarea used to give a description of the picture in the database
   echo "<TR><TD>Description:</TD>\n";
   echo "<TD COLSPAN=5><TEXTAREA NAME=\"description\" ROWS=\"6\" 
          COLS=\"50\" tabindex=100>";
   if($description)
      echo $description;
   else
      echo "Fill in some text here.";
   echo "</TEXTAREA></TD>\n";

   // Checkbox to indicate that the image has not been manipulated
   if ($raw_data && $raw_data !="f")
      $checked = "checked";
   else
      $checked = "";
   echo "<TR><TD>Raw data?</TD><TD><input type=\"checkbox\" $checked 
          name=\"raw_data\" value=\"on\" tabindex=150>\n";
//   print_exp_date ($exp_date);
     echo "<INPUT TYPE=Hidden NAME=exp_date_box value=checked>";

   echo "</TD></TR>\n ";
   echo "</TABLE><HR><TABLE>\n";
 
   echo "<TR><TD><H4>Who may see this image?</H4></TD><TD></TD><TD></TD>";    

   // multiple select box for keywords
   print_group_keywords ("<H4>Keywords</H4>", "multiple", 11, "keys[]", 
                          $keys, true);
   // selection box for projects
   box_projects ($projectid, "<h4>Project</h4>", false, "projects[]", true,11);

   echo "</TR>";

   // set default to viewright to 'group only'
   if ( !($viewrights)  && !( ($private == "t") || 
                          ($restrict_to_group == "t") || ($everyone == "t") ) )
      $restrict_to_group = "t";
   // Checkbox to make a picture private to the user logged onto the system.
   if ( ($private && $private !="f") || ($viewrights == "private") )
     $checked = "checked";
   else
      $checked = "";
    echo "<TR><TD>Me:</TD><TD><input type=\"radio\" name=\"viewrights\" 
                               value=\"private\" $checked></TD>\n";

   // Checkbox to make a picture visible only to the group the users belongs to.
   if ( ($restrict_to_group && $restrict_to_group!="f") || 
        ($viewrights == "restrict_to_group") )
      $checked = "checked";
   else
      $checked = "";
   echo "<TR><TD>My Group:</TD><TD><input type=\"radio\" name=\"viewrights\" 
         value=\"restrict_to_group\" $checked></TD>\n ";

   //Checkbox to make a picture visible to everyone.
   if ( ($everyone && $everyone!="f") || ($viewrights == "everyone") )
      $checked = "checked";
   else
      $checked = "";
   echo "<TR><TD>Everyone:</TD><TD><input type=\"radio\" $checked 
              name=\"viewrights\" value=\"everyone\" $checked></TD>\n ";

   //box_users ($trust_array,"and also:");
   box_users ($trust_array,"and also:", false,"trust_array[]","multiple");

   //to help remember the user which keywords were initially selected:
   if ($new_modify=="modify")
      if ($keywords_string = show_keywords ($imageid) )
         echo "<TR><TD></TD><TD></TD><TD>Assigned keywords:</TD>
               <TD>$keywords_string</TD></TR>";

   echo "</TABLE>\n";
   echo "<HR>\n";
 
   $box_size="size=6";

   // 2-D specific stuff (physical size of pixel in nm)
   if ($filetype=="2-D" || $filetype=="multipage") {
      echo "<TABLE>\n";
      echo "<TR><TD><H5>Pixelsize (nm)</H5></TD>\n";
      echo "<TD>&nbsp &nbsp x </TD>";
      echo "<TD><input type ='TEXT' name='x_nm' value='$x_nm' 
                 tabindex=400 $box_size></TD>\n";
      echo "<TD>&nbsp &nbsp y </TD>";
      echo "<TD><input type ='TEXT' name='y_nm' value='$y_nm' 
                 tabindex=400 $box_size></TD>\n";
      echo "</TR></TABLE>\n<HR>\n";
   } 

   // Thumbnail size
   if ($filetype <> "other") {
      echo "<TABLE>\n";
      echo "<TR><TD COLSPAN=4 align='left'><H5>Thumbnail size (pixels)</H5>
            </TD></TR>\n";
      echo "<TR><TD>x thumbnail size</TD>";
      echo "<TD><input type='TEXT', name='x_thumb', value='$x_thumb' 
                 tabindex=250 $box_size></TD>\n"; 
      echo "<TD>&nbsp &nbsp y thumbnail size</TD>";
      echo "<TD><input type='TEXT', name='y_thumb', value='$y_thumb' 
                 tabindex=300 $box_size></TD>\n"; 
      if ( ($filetype=="multipage") || ($filetype=="3-D") || ($filetype=="ICS") ) {
         print_fs_thumb ($fs_thumb);
      }
      echo "</TR>\n";
      echo "</TABLE>\n";
      echo "<HR>\n";
   }

   // 3-D specific fields
   if ( ($filetype=="3-D") || ($filetype=="ICS") ) {
      echo "<TABLE>\n";
      echo "<TR><TD COLSPAN=2><H5>Geometry (nm, sec)</H5></TD></TR>";
      echo "<TR>";
      echo "<TD>x sample size</TD>";
      echo "<TD><input type ='TEXT' name='x_nm' value='$x_nm' 
                 tabindex=400 $box_size></TD>\n";
      echo "<TD>y sample size</TD>";
      echo "<TD><input type ='TEXT' name='y_nm' value='$y_nm' 
                 tabindex=410 $box_size></TD></TR>\n";
      echo "<TR><TD>z sample size</TD>";
      echo "<TD><input type ='TEXT' name='z_nm' value='$z_nm' 
                 tabindex=420 $box_size></TD>\n";
      echo "<TD>t sample interval</TD>";
      echo "<TD><input type ='TEXT' name='t_sec' value='$t_sec' 
                 tabindex=430 $box_size></TD></TR>\n";
      echo "</TABLE>\n";
      echo "<HR>\n";

      echo "<TABLE cellspacing=\"0\" border=0>\n";
      $color_pars = "bgcolor=\"#FFEE88\"";
      $color_ri = "bgcolor=\"#FFBBFF\"";
      echo "<TR><TD COLSPAN=2 $color_pars><H5>Optical parameters</H5>
            </TD><TD $color_pars>&nbsp&nbsp&nbsp</TD><TD $color_ri>&nbsp</TD>";
      echo "<TD COLSPAN=2 $color_ri><H5>Refractive indexes</H5></TD></TR>\n"; 
      print_microscopes($microscope_type, false, $color_pars);
      echo "<TD $color_pars>&nbsp&nbsp&nbsp</TD>\n";
      echo "<TD $color_ri>&nbsp &nbsp Lens</TD><TD $color_ri>
            <INPUT TYPE ='TEXT' NAME='refrinxlensmedium' 
             VALUE='$refrinxlensmedium' tabindex=510 size=15></TD></TR>\n";
      echo "<TD $color_pars>Numerical aperture</TD><TD $color_pars>
            <INPUT TYPE ='TEXT' NAME='numaperture' VALUE='$numaperture' 
             tabindex=500 size=15></TD>\n";
      echo "<TD $color_pars>&nbsp&nbsp&nbsp</TD>\n";
      echo "<TD $color_ri>&nbsp &nbsp Medium</TD><TD $color_ri>
            <INPUT TYPE ='TEXT' NAME='refrinxmedium' VALUE='$refrinxmedium' 
             tabindex=520 size=15></TD></TR>\n";
      echo "</TABLE>\n";
      print_channel_form ($imageid, 1, $templateid);
   }
   echo "<TABLE>\n";
}

////
// !Enters image meta-data into the database
// called from upload.php and imagemod.php
function upload_database ($do_modify=false) {
   global $location, $location_name, $location_type, $desc, $S_USERID;
   global $filesize, $imagename, $imageid, $HTTP_POST_VARS, $image_fields;
   global $default_thumb_size, $max_thumb_size, $min_thumb_size,$old_postgres;
   global $S_STATUS,$G_SUPER,$G_ADMIN,$thismd5,$image_upload_directory,$upload_as_user;

   // creates variables from all values passed by http_post_vars, 
   // skips ones that are already set
   extract ($HTTP_POST_VARS, EXTR_PREFIX_SKIP, "post_vars");
   echo "<!-- uploading database with $location $location_name -->\n";   

   // determine microscope type
   $microscope_type = get_array_value ($scope);
   // determine selected frame rate
   $fs_thumb = get_array_value ($fs);
   // determine selected project
   $projectid=$projects;

   // determine expiration date
   if ($exp_date_box)
      $exp_date = 0;
   else
      $exp_date = get_unix_time ($exp_date_text); 

   // determine trustable user
   $trust = last_array_value ($trust_array);

   if (! $do_modify) {

      // Get filename from URL.
      $imagename = $location_name;
      //this is the name of the image file cut from original location
   
      // set variables whose names do not (yet) equal their names in the table
      $date_time = time();
      $filename = $location_name;
      $userid = $S_USERID;
      if (($S_STATUS ==$G_SUPER || $S_STATUS == $G_ADMIN)  && $upload_as_user>0 && $as_user != $S_USERID
	 && valid_user($upload_as_user)) {
	 $userid=$upload_as_user;
      }
      $mime=$location_type;
      if (!$filesize)
         $filesize=filesize($location);
      $md5sum=md5_file($location);
      $thismd5=$md5sum;
      echo "<!-- md5sum = $md5sum $location_name $location -->\n";
      // if not known yet, try to get the filename-extension and mime-type for 
      // 2-D and other files
      if ( ($filetype == "2-D") || ($filetype == "other") ||
           ($filetype=="multipage") ) {
         if (!($filetype_extension)) 
            $filetype_extension = get_filename_extension ($filename);
         if (!($mime)) {
            $mime = get_mime_type ($filetype_extension);
         }
      }
   } 

   // deal with description
   if ($description == "Fill in some text here.")
      $description = $imagename;
   $description = strip_tags ($description, "<a><i><b><hr><br><p>");

   // make sure we do not exceed the tuple size of PostgresQl 
   // (wished I could get that value somewhere dynamically
   if ($old_postgres && strlen ($description) > 8100) {
      echo "<h3>The description field is too large.  
            It has been truncated to 8100 characters.</h3>\n";
      $description = substr ($description, 0, 8100);
   }

   $test = true;

   if (! $do_modify) {
      $query1 = "INSERT INTO images (";
      $query2 = ") VALUES (";
   }
   else { // we are only updating the meta-data
      $query1 = "UPDATE images SET ";
   }

   $fieldname = strtok ($image_fields,",");
   $i = 0;
   while ($fieldname) {
      $fieldname_value = ${$fieldname};
      // adjust settings for booleans
      if ($fieldname == "raw_data") {
         if ($fieldname_value == "on")
            $fieldname_value = "t";
         else
            $fieldname_value = "f";  
      }
      if ( $fieldname == "private" || $fieldname == "restrict_to_group" || 
           $fieldname == "everyone") {
         if ($viewrights == $fieldname)
            $fieldname_value = "t";
         else 
            $fieldname_value = "f";
      }

      // check types of numeric fields and change when needed
      if ($fieldname == "channels" || $fieldname == "x_thumb" || 
          $fieldname == "y_thumb") 
         $fieldname_value = (int) $fieldname_value;
      if ($fieldname == "x_thumb" || $fieldname == "y_thumb") {
         $fieldname_value = trim ($fieldname_value);
         if (!($fieldname_value))
            $fieldname_value = $default_thumb_size;
         else {
            if ($fieldname_value > $max_thumb_size)
               $fieldname_value = $max_thumb_size;
            if ($fieldname_value < $min_thumb_size)
               $fieldname_value = $min_thumb_size;
         }
      }
      if ($fieldname == "refrinxmedium" || $fieldname == "numaperture" || 
          $fieldname == "refrinxlensmedium" ||
          $fieldname == "x_nm" || $fieldname == "y_nm" || 
          $fieldname == "z_nm" || $fieldname == "t_sec") 
             $fieldname_value = (float) $fieldname_value;
      $fieldname_value = trim ($fieldname_value);

      if ($fieldname_value || $fieldname == "exp_date" && 
          ( !($fieldname_value ==" " || $fieldname == "imageid" ||
              $fieldname == "imageid" || $fieldname == "imagename" || 
              $fieldname == "locationid"|| $fieldname == "md5sum") ) ) {

        if($test) {  // only the first time without comma
            $test = false;
            if ($do_modify)
               $query1 .= $fieldname . "='" . $fieldname_value . "'";
            else {
               $query1 .= $fieldname;
               $query2 .= "'" .$fieldname_value . "'";
            }
         }
         else {
            if ($do_modify)
               $query1 .= ", " . $fieldname . "='" . $fieldname_value . "'";
            else {
               $query1 .= ", " .$fieldname;
               $query2 .= ",'" .$fieldname_value ."'";
            }
         }
      }
      $fieldname=strtok(",");
   }

   if ($do_modify)
      $query = $query1 . " WHERE imageid=$imageid;";
   else
      $query = $query1 . $query2 . ");";

   db_exec ("BEGIN WORK;");
   
   do_database_query($query);

   if (!$do_modify) {
      $result = do_database_query("SELECT imageid FROM images WHERE 
                 filename='$location_name' AND date_time='$date_time';");
      $a = db_fetch_array($result,0);
      $imageid = $a["imageid"];
   }
   if ($imageid) {
      $test = true;
      if ($do_modify) {
         if (! uncouple_all_keywords_from_image ($imageid))
            $test = false;
         // when expiration date was reset, delete exp_mail_date
         if (! $exp_date)
            if (! db_exec ("UPDATE images SET exp_mail_date = NULL WHERE
                            imageid='$imageid'") )
               $test = false;
      }   
      // set time-stamp only with new upload, not when modifying
      if (!$do_modify) {
         // set the timestamp to identify this upload in user's account
         $set_stamp = "UPDATE users SET last_action='$time_stamp', 
                       last_image='$imageid' WHERE userid='$S_USERID';";
         if (!(do_database_query ($set_stamp)) )
            $test=false;
      }
      // add keywords
      if ($keys) {
         reset ($keys); 
         while (list(, $value) = each ($keys)) {
            if ($value)
               if (!couple_keyword_to_image ($value, $imageid))
                  $test=false;
         }
      } 
      // add projects, delete existing ones
      $query = "DELETE FROM projectximages WHERE imageid=$imageid";
      do_database_query ($query);
      if ($projectid) {
         for ($i=0; $i<sizeof($projectid); $i++) {
            $query = "INSERT INTO projectximages VALUES
                      ('$projectid[$i]', '$imageid')";
            if (! do_database_query ($query))
               $test = false;
         }
      } 
      // add trusted users,  delete existing ones
      $query = "DELETE FROM imagextrust WHERE imageid=$imageid";
      do_database_query ($query);
      if ($trust_array) {
         for ($i=0; $i<sizeof($trust_array); $i++) {
            $query = "INSERT INTO imagextrust VALUES
                      ('$imageid','$trust_array[$i]')";
            if (! do_database_query ($query))
               $test = false;
         }
      }
      // add channels
      if ( ($filetype=="3-D") || ($filetype=="ICS") )
      if (! (store_channels ($imageid, 1)) )
          $test = false;

      if ($test) {
         db_exec ("COMMIT WORK;");
         return true;
      }
      else {
         db_exec ("ROLLBACK WORK;");
         echo "Problems saving your changes!";
         return false;
      }
   }
   else {
      db_exec ("ROLLBACK WORK;");
      if ($do_modify)
         do_error ("Weird internal error.... Sorry;(");
      else
         do_error ("Failed to insert image into the database"); 
      return false;
   }
}


?>
