<?php

// init_inc.php - Basic and common functions.  
// init_inc.php - author: SVI group University Utrecht and Nico Stuurman
  /***************************************************************************
  * This file contains all basic and common functions needed by the php      *
  *  scripts.                                                                *
  * Last update by Frank on 15-06-2000. Added new funcitons                  *
  * things.                                                                  *
  * 8/1/00, Nico, Changed imgdel.  At this point $filename is not defined and*
  * therefore imgdel used to fail. Added function imgviewrights              *
  ***************************************************************************
  * opendatabase()                                                           *
  * closedatabase()                                                          *
  * globalize_vars ($var_string, $type)                                      *
  * make_args ($arg_string)                                                  *
  * nice_bytes ($bytes)                                                      *
  * last_array_value ($array)                                                *
  * imgdel($imageid)                                                         *
  * imgrights($imageid)                                                      *
  * projrights($projectid)                                                   * 
  * get_image_location                                                       *
  *     ($imageid, $filename="", $ownerid=0, $owner_group_id=0)              *
  * thumb_name ($id, $thumb_nr, $extension="jpg")                            *
  * project_image ($projectid, $size)                                        * 
  * get_users_group ($user)                                                  *
  * groupname ($groupid)
  * projright_query ($user, $fields, $clause=false)                          * 
  * projviewrights ($id, $user)                                              * 
  * imgright_query ($user, $fields, $clause)                                 *
  * imgviewrights ($im_id, $user) {global $S_GROUPID                         *
  * translate($columnname)                                                   *
  * makebutton($string, $url, $status, $size)
  * printheader()                                                            *
  * printfooter()                                                            *
  * randomImage($imagedir)
  * display_meta_data($screen)
  ***************************************************************************
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: nicost@sf.net                                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/  


//global constants

//hierarchy of users
$G_GUEST = 20;
$G_USER  = 100;
$G_ADMIN = 200;
$G_SUPER = 300;

// global settings 
set_magic_quotes_runtime (0);

// is it http or https?
$ssl=getenv("SSL_PROTOCOL");
if ($ssl)
   $http_method="https";
else
   $http_method="http";

// determine sidb_root on the fly
//$fds=explode("/",$HTTP_SERVER_VARS["PHP_SELF"]);
//if ($fds)
//   $fds="/".$fds[1];
//$sidb_root=getenv("HTTP_HOST").$fds;
//
// WHY???? re-create on the fly?
// It is a global setting by the configuration file.
// We do not want to change it. ESPECIALLY when it
// is re-created WRONG. It left out the last 
// directory! Grmbl:-)  -Frank

////
// !function to open connection to database
function opendatabase() {
   global $db_conn, $db_name, $db_user, $db_pass;
   $db_conn = pg_connect("dbname=$db_name user=$db_user password=$db_pass");
   if (!$db_conn):
      echo "ERROR: can't connect to database!";
   endif;
}

////
// !function to close connection to database
function closedatabase() {
   global $db_conn;
   @pg_close($db_conn);
}

////
// !returns the url base of sidb
function sidb_root () {
   global $HTTP_SERVER_VARS;

   $DOCUMENT_ROOT = getenv ("HTTP_HOST");
   $PORT = getenv ("SERVER_PORT");
   if ($PORT <> 80)
      $DOCUMENT_ROOT .= ":" . $PORT;
   $PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];
   $last = strrpos ($PHP_SELF, "//");
   $sidbroot = $DOCUMENT_ROOT . substr ($PHP_SELF, 0, $last);
   return $sidbroot;
}

////
// !checks wether variables are present in ${type} and makes them available
// variables are only set when they are not null in ${type}
// $var_string is a comma delimited list
function globalize_vars ($var_string, $type) {
   global ${$type};

   if ($var_string && $type) {
      $var_name = trim(strtok ($var_string, ","));
      global ${$var_name};
      if (!${$var_name})
         ${$var_name} = ${$type}["$var_name"];
      while ($var_name) {
         $var_name = trim(strtok (","));
         global ${$var_name};
         if (!${$var_name})
            ${$var_name} = ${$type}["$var_name"];
      }
   }
}

////
// !returns a string to be passed as HTTP_GET_VARS  
function make_args ($arg_string) {
   if ($arg_string) {
      $arg_name = trim(strtok ($arg_string, ","));
      global ${$arg_name};
      if (${$arg_name})
         $args .= "&$arg_name=${$arg_name}";
      while ($arg_name) {
         $arg_name = trim(strtok (","));
         global ${$arg_name};
         if (${$arg_name})
            $args .= "&$arg_name=${$arg_name}";
      }
   return $args;
   }
}

////
// !returns a string with a 'nice' representation of the input number of bytes
function nice_bytes ($bytes) {
   $last = $bytes[strlen($bytes)-1];
   $bytes = (float) $bytes;
   if (!is_float($bytes) ) return false;
   if ($last == "M") $bytes = $bytes*1048576;
   if ($bytes==0) return "0 bytes";
   elseif ($bytes==1) return "1 byte";
   elseif ($bytes < 1024) return "$bytes byte";
   elseif ($bytes < 16384) {
      $bytes = $bytes/1024;
      $bytes = number_format($bytes,1);
      return "$bytes kB";
   }
   elseif ($bytes < 1048576) {
      $bytes = $bytes/1024;
      $bytes = number_format($bytes,0);
      return "$bytes kB";
   }
   elseif ($bytes < 16777216) {
      $bytes = $bytes/1048576;
      $bytes = number_format($bytes,1);
      return "$bytes MB";
   }   
   elseif ($bytes < 1073741824){
      $bytes = $bytes/1048576; 
      $bytes = number_format($bytes,0);
      return "$bytes MB";      
   }
   elseif ($bytes >= 1073741824) {
      $bytes = $bytes/1073741824;
      $bytes = number_format($bytes,1);
      return "$bytes GB";
   }        
   else return "$bytes byte";
}

////
// !returns value of last item in array, useful for html lists
function  last_array_value ($array) {
   if ($array && is_array($array)) 
      while (list(, $value) = each ($array)) {
         return $value;
      }
}

////
// !function to delete an image.  
// call from within BEGIN WORK -- COMMIT/ROLLBACK pairs
function imgdel($imageid) {
   global $S_USERID,$archive_dir,$thumbnail_dir,$filename,$filetype;

   if(imgrights($imageid)):
	
      // determine $filename
     $query = "SELECT filename,filetype,thumb_nr,compressed FROM images WHERE imageid =$imageid";
     $search_result = db_exec($query);
     if($search_result):
         $number_of_results = db_numrows($search_result);
         if($number_of_results==1):
           $r = db_fetch_array($search_result,0);
           $filename = $r["filename"];
           $filetype = $r["filetype"];
           $thumb_nr = $r["thumb_nr"]; 
           $compressed = $r["compressed"];

           // db_exec ("BEGIN WORK");
           $query_remove_from_imagestable = "DELETE FROM images WHERE imageid = $imageid ;";
           if (db_exec($query_remove_from_imagestable)) {
              $query_keys = "DELETE FROM imagexkeywords WHERE imageid=$imageid;";
              $query_projects="DELETE FROM projectximages WHERE imageid=$imageid";
              if (db_exec ($query_keys) && db_exec($query_projects)) ; //db_exec ("COMMIT WORK");
              else return false; //pg_exec ("ROLLBACK WORK");
           }
           else
              return false; //pg_exec ("ROLLBACK WORK");   
           
           //remove from physical location
           //remove file
           if ($compressed=="t") 
           {
              $w = escapeshellarg("$archive_dir/".$imageid."_".$filename.".gz");
              $w = system ("rm $w");
           }
           else
           {
              $w = escapeshellarg("$archive_dir/".$imageid."_".$filename);
              $w = system ("rm $w");
           }
           if ($filetype == "ICS"):
              $filename = str_replace (".ics", ".ids.gz", $filename);
              $filename = str_replace (".ICS", ".IDS.GZ", $filename);
              $w = escapeshellarg("$archive_dir/".$imageid."_".$filename);
              $w = system ("rm $w");
              if ($compressed=="t") {
                 $w = escapeshellarg("$archive_dir/".$imageid."_".
                                     $filename.".gz");
                 $w = system ("rm $w");
              }
           endif;
           $filename = "";
           $filetype = "";

           //remove all thumbs
           system ("rm $thumbnail_dir/big/".thumb_name ($imageid, $thumb_nr) );
           system ("rm $thumbnail_dir/small/".thumb_name ($imageid, $thumb_nr) );
           system ("rm $thumbnail_dir/movie/".thumb_name ($imageid, $thumb_nr, "mpg") );

        endif; //number_of_results==1
     endif;  //image found
   return true;  
   endif;
}


////
// !Returns path/filename for an image
function get_image_location ($imageid, $ids=false, $filename=false, $ownerid=0, $owner_group_id=0) {
   global $archive_dir;

      // when no default values have been given:
   if (!($filename) || ($ownerid=0) ) {
     // determine missing values;
     $query = "SELECT filename, userid FROM images WHERE imageid = $imageid;";
     $search_result = db_exec($query);
     if ($search_result) {
        if (db_numrows($search_result)==1) {
           $r = db_fetch_array($search_result,0);
           $ownerid = $r["userid"];
           $filename = $r["filename"];
           $query = "SELECT groupid FROM users WHERE userid = $ownerid;";
           $search_result2 = db_exec ($query);
           if ($search_result2) {
              if (db_numrows($search_result2)==1) {
                 $r2 = db_fetch_array($search_result2,0);
                 $owner_group_id=$r2["groupid"];
               }
               else return false;
            }   
            else return false;
         }   
         else return false;
      }
      else return false;
   }
/*   This is for later extensions, to store files in subdirectories
 // when ownersgroup is lacking:
   elseif ($owner_group_id == 0) {
      $search_result2 = db_exec ($query);
      if ($search_result2) {
         if (db_numrows($search_result2)==1) {
            $r2 = db_fetch_array($search_result2,0);
            $owner_group_id=$r2["groupid"];
            // now get groups directory name
         }
         else return false;
      }   
      else return false;
   }
*/ 
   // all information available, make the string:
   if ($ids) {
       $filename = str_replace (".ics", ".ids.gz", $filename);
       $filename = str_replace (".ICS", ".IDS.GZ", $filename);
   }

   // return the string quoted to avoid problems with spaces
   return $archive_dir."/".$imageid."_".$filename;      
}    

////
// !uncompresses compressed images
function uncompress ($imageid) {
   global $bzip2;

   $location = get_image_location ($imageid);
   // be stupid and try for bzip2 and gzip extension 
    $loc = escapeshellarg($location .".gz");
    system("$bzip2 -d $loc");
    $loc = escapeshellarg($location . ".bz2");
    system("$bzip2 -d $loc"); 

   // check for ics/ids:
   if (get_image_info($imageid, "filetype")=="ICS")
   {
      $location = str_replace (".ics", ".ids.gz", $location);
      $location = str_replace (".ICS", ".IDS.GZ", $location);
      $loc = escapeshellarg($location .".gz");
      system("$bzip2 -d $loc");
      $loc = escapeshellarg($location . ".bz2");
      system("$bzip2 -d $loc"); 
   }   
   if (filesize($location))
   {
      $query = "UPDATE images SET compressed='f' WHERE imageid=$imageid";
      do_database_query ($query);
      return true;
   }
   else 
   {
      return false;
   }
}

////
// !compresses uncompressed ids images
function compressids($imageid, $locationids_name)
{
    if (get_image_info($imageid, "filetype") == "ICS")
    {
        // location of the zip binary
        global $bzip2;
	global $archive_dir;
	$location = $archive_dir."/".$imageid."_".$locationids_name;

        // CHECK the extension of the ids file
        // to determine if it is zipped or not
	if (substr($locationids_name, -4) == ".ids" 
            || substr($locationids_name, -4) == ".IDS")
	{
	    Debug::printDebug("COMPRESSING: $locationids_name");
            // change location to the ids file!
            // This wildcard command is to avoid conflicts with
            // special characters in the gzip.
            if (substr($locationids_name, -4) == ".ids")
            {
              $loc = $archive_dir."/".$imageid."_*.ids";
            }
            else
            {
              $loc = $archive_dir."/".$imageid."_*.IDS";
            }
	    $cmd="$bzip2 $loc";
	    Debug::printDebug("LOC: $loc, CMD: $cmd");

	    $fd = popen("$cmd 2>&1", "r");
	    if (!$fd)
	    {
		print("Could not do <b>$cmd</b>");
	    }
	    else
	    {
		$line = fgets($fd, 1024);
		$firstline = trim($line);
		while (isset($fd) && !feof($fd))
		{
		    $lastline = chop($line);
		    $line = fgets($fd, 1024);
                    print("LASTLINE: $lastline");
		}
		pclose($fd);
	    }
            Debug::printDebug("DONE COMPRESSING: $loc");
            $location = $location . ".gz";
            $newsize = filesize($location);
            Debug::printDebug("File $location is now $newsize");
            return $newsize;
        }
        else
        {
           $oldsize = filesize($location);
           Debug::printDebug("NO NEED FOR COMPRESSING: $location is $oldsize");
           return $oldsize;
       }

	// ELSE the .ids file is already zipped and that's
	// just the way we want to store it! ha!
    }
}

         
////
//!To work around caching problems thumbnails need to be renamed after changing them
// this function generates the tumbname from the information provided
function thumb_name ($id, $thumb_nr, $extension="jpg") {
   if ($thumb_nr)
      return $id."_".$thumb_nr. "." .$extension;
   else 
      return "$id. "." .$extension";
}

////
// !returns the thumbnail of a project.  $size can be big or small
function project_image ($projectid, $size) {
   global $thumbnail_dir;

   if ($size == "small" || $size == "big") {
      $thumb = "$thumbnail_dir/projects/$size/$projectid.jpg";
      if (file_exists ($thumb) )
         return $thumb;
   }
   return false; 
}

////
// !determines wether the user has the rights to edit/delete an image
function imgrights($imageid) {
   global $S_STATUS, $S_LOGIN, $S_USERID, $S_GROUPID;
   global $G_SUPER, $G_USER, $G_GUEST;

   if ($S_STATUS == $G_SUPER) return true;
   if ($S_STATUS == $G_GUEST) return false;

   //get userid of owner
   $query_auth = "SELECT userid FROM images WHERE imageid = $imageid ;";
   $result = db_exec($query_auth);
   $result_array = db_fetch_array($result,0);
   $ownerid = $result_array["userid"];
   if ($ownerid == $S_USERID) return true;

   //get group and status of user who owns image
   $query = "SELECT groupid,status FROM users WHERE userid=".$ownerid.";";
   $result = db_exec($query);
   $result_array = db_fetch_array($result,0);
   $group_of_owner = $result_array["groupid"];;
   $status = $result_array["status"];
   if (($S_GROUPID==$group_of_owner) && ($S_STATUS > $G_USER)) return true; 
   
   return false;
}

////
// !determines wether the user has the rights to edit/delete a project 
function projrights($projectid) {
   global $S_STATUS, $S_LOGIN, $S_USERID, $S_GROUPID;
   global $G_SUPER, $G_USER, $G_GUEST;

   if ($S_STATUS == $G_SUPER) return true;
   if ($S_STATUS == $G_GUEST) return false;

   //if user=owner, it is OK
   $query_auth = "SELECT userid FROM projects WHERE projectid=$projectid ;";
   $result = db_exec($query_auth);
   $result_array = db_fetch_array($result,0);
   $ownerid = $result_array["userid"];
   if ($ownerid == $S_USERID) return true;

   // groupadmins also can do it
   $query = "SELECT groupid,status FROM users WHERE userid=".$ownerid.";";
   $result = db_exec($query);
   $result_array = db_fetch_array($result,0);
   $group_of_owner = $result_array["groupid"];;
   $status = $result_array["status"];
   if (($S_GROUPID==$group_of_owner) && ($S_STATUS > $G_USER)) return true; 
   
   return false;
}

////
// !function to find user's group, ehmm, this one is not really needed
function get_users_group ($user) {
return $S_GROUPID;
}

////
// !function that returns the groupname, given a groupid
function groupname($groupid) {
   $db_query = "SELECT groupname FROM groups WHERE groupid='$groupid'";
   $db_result = db_exec($db_query);
   $db_rows = db_numrows($db_result);
   if ($db_rows == 1):
      $db_row_result = db_fetch_array($db_result, 0);
      return $db_row_result["groupname"];
   else:
      return "Group with that groupid does not exist!";
   endif;
}


////
// !generate part of SQL statement to determine whether a user may see 
// the project
function projright_query ($user, $fields, $clause=false) {
   global $S_GROUPID, $S_STATUS, $G_SUPER;

   $query = "SELECT $fields FROM projects ";
   if ($S_STATUS <> $G_SUPER) {
      $query .= " WHERE ";
      if ($clause)
         $query .= " $clause AND ";
      // if owned it is OK
      $query .= "( (userid='$user') OR ";
      // when group only and member of group it is OK
      $query .= "( (rights='2') AND ($S_GROUPID="; 
      $query .= "(SELECT groupid FROM USERS 
                  WHERE USERS.userid=projects.userid) ) ) OR ";
      $query .= "(rights='4')  )";
   }
   else
      if ($clause)
         $query .= " WHERE $clause ";
   return $query; 
}   

////
// !Determines whether or not a user has the right to see a project
function projviewrights ($id, $user) {
   $query  = projright_query ($user, "name", "(projectid = $id)").";";
   $search_result = do_database_query ($query);
   if($search_result):
      $number_of_results = db_numrows($search_result);
      if($number_of_results==1):
        return true;
      endif;
   endif;
   return false;
}


////
// !generates (part) of SQL statement to determine whether 
// a user may see this image
function imgright_query ($user, $fields, $clause) {
   global $S_GROUPID, $S_STATUS, $G_SUPER;

   $audit_groups = get_audit_groups ($user);
   $groupid = $S_GROUPID;
 
   $query = "SELECT $fields FROM images ";
   if ($S_STATUS <> $G_SUPER) {
      $query .= " WHERE ";
      if ($clause)
         $query .= " $clause AND ";
      $query .= "( ( (private = '0') AND (restrict_to_group = '0'";
      $query .= " OR ($groupid = (SELECT groupid FROM USERS WHERE USERS.userid = images.userid)) ";
      if (is_array($audit_groups)) {
         for ($i=0; $i<sizeof($audit_groups);$i++)
            $query .= " OR ($audit_groups[$i] = (SELECT groupid FROM users WHERE USERS.userid = IMAGES.userid)) ";
      }
      $query .= ")) OR images.imageid IN (SELECT imageid FROM imagextrust WHERE imagextrust.userid='$user') ";
      $query .= " OR images.userid='$user') ";
   }
   else
      if ($clause)
         $query .= " WHERE $clause ";
   //echo "$query<Br>"; 
   return $query; 
}

////
// !function to determine whether or not a user has the right to see an image
function imgviewrights ($im_id, $user) {
   $query  = imgright_query ($user, "filename", "(imageid = $im_id)").";";
   $search_result = do_database_query ($query);
   if($search_result):
      $number_of_results = db_numrows($search_result);
      if($number_of_results==1):
        return true;
      endif;
   endif;
   return false;
}

////
//!Translates a columnname into plain english
function translate($columnname){
   $result = db_exec("SELECT translation FROM translate WHERE columnname = '$columnname';");
   $numberofrows = db_numrows($result);

   if ($numberofrows == 0):
      return $columnname ;
   else:
      $array = db_fetch_array($result, 0);
      $return = $array["translation"];
      return $return ;
   endif;
}


////
// !Generates buttons, based on Fireworks3 output
function makebutton ($string, $url, $status, $size)
{
    // change %20 into %25
    $string2 = str_replace ("%20", " ", $string);
    $html = "<a href=\"$url\">$string2</a>";
    print $html;
}

////
// !Prints header of each html page
// $include is the path to a javascript js file, relative to include dir 
function printheader ()
{
    global $S_LOGIN, $S_STATUS, $PHP_SELF, $G_USER, $G_ADMIN, $G_SUPER;
    global $title, $include_dir;
    global $logo, $logo_x_size, $logo_y_size, $logo_link;

    // first the anti-caching headers
    header("Cache-control: private, no-cache, must-revalidate");
    header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
    header("Pragma: no-cache");

    // then actual html
    print("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\" ".
	    "\"http://www.w3.org/TR/html4/loose.dtd\">");
    print("<html>");
    print("<head>");
    print("<meta http-equiv=\"Content-Script-Type\" ".
          "content=\"text/javascript\">");
    print("<title>$title</title>");
    print("<link rel=\"stylesheet\" type=\"text/css\" href=\"svi.css\">");

    // print javascript
    print("<script language='Javascript'>\n");
    print("<!--\n"); 
    $num_args = func_num_args();
    if ($num_args > 0)
    {
        for ($i=0; $i < $num_args; $i++)
	{
	    $teststring = func_get_arg($i);
	    $testarray = explode("\n",$teststring);
	    // when a single line has been given, 
	    // include file, otherwise echo string
	    if (sizeof($testarray)==1) 
	    {
	        include ("$include_dir/$teststring");
	    }
	    elseif (sizeof($testarray) > 1)
	    {
		print("\n$teststring\n");
	    }
        }
    }
    print("// End Javascript -->\n");
    print("</script>\n");

    print("</head>");
    print("<body bgcolor=\"#ffffff\">");
    print("<a name=\"top\"></a>");

    print("<table cellpadding=6 cellspacing=0 border=0 width=\"100%\" ".
	   "bgcolor=\"#ffffff\" background=\"images/steel3.jpg\">");

    // first row, containing title
    print("<tr>");
    if ($S_LOGIN)
    {
	print("<td align=\"right\">");
	print("<i>$S_LOGIN</i>");
	print("</td>");
    }
    else
    {
	print("<td>&nbsp;</td>");
    }
    print("<td valign=\"middle\">");
    // table containing title and Help button
    print("<table width=\"100%\" cellpadding=0 cellspacing=0 border=0 ".
          "align=\"right\">");
    print("<tr>");
    print("<td width=\"70%\" align=\"center\"><b>$title</b></td>");
    // only print help button when logged in
    if ($S_LOGIN)
    {
	$ref = substr(basename($PHP_SELF), 0, -4);
	print("<td align=\"right\" width=\"10%\">");
	makebutton("on topic help", "help.php#$ref", "It might help", "large");
	print("</td>");
    }
    if ($S_STATUS > $G_ADMIN) 
      {
	print("<td align=\"right\" width=\"10%\">");
	makebutton("Source", "source.php", "view the source of this page", "large");
		print("</td>");
      }
    print("</tr>");
    print("</table>");
    print("</td>");
    print("</tr>");
    // end first row
    
    // second row, containing buttons and body
    print("<tr>");
    // start first column
    print("<td align=\"center\" valign=\"top\">");
    // table containing large buttons
    print("<table width=80>");
    // buttons to print when NOT logged in
    if (!isset($S_LOGIN))
    {
	print("<tr><td><br><b><big>Information</big></b></td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("about", "index.php", "about", "large");
	print("</td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("credits", "credits.php", "credits", "large");
	print("</td></tr>");
	//print("<tr><td align=\"right\">");
	//makebutton("tutorial", "tutorial.php", "tutorial", "large");
	//print("</td></tr>");

	print("<tr><td><br><b><big>Session</big></b></td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("login", "login.php", "login", "large");
	print("</td></tr>");
    }
    // buttons to print when logged in
    else
    {
	print("<tr><td><b><big>Images</big></b></td></tr>");

	print("<tr><td align=\"right\">");
	makebutton("search", "search.php", "search the database", "large");
	print("</td></tr>");

	print("<tr><td align=\"right\">");
	makebutton("my pictures", "search.php?action=mypics", 
	           "view my pictures", "large");
	print("</td></tr>");

        if ($S_STATUS > $G_ADMIN)
        {
            print("<tr><td align=\"right\">");
            makebutton("clean archive", "clean.php?action=list", 
                       "clean archive", "large");
            print("</td></tr>");
        }

	
	print("<tr><td align=\"right\">");
	makebutton("upload", "upload.php", "upload images", "large");
	print("</td></tr>");

	print("<tr><td></td></tr>");

	if ($S_STATUS > $G_USER)
	{ 
	    print("<td><br><b><big>Administrate</big></b></td></tr>");
	    print("<tr><td align=\"right\">");
	    makebutton("users", "adminusers.php", 
	               "User Administration", "large");
	    print("</td></tr>");


	    if ($S_STATUS > $G_ADMIN)
	    {
		print("<tr><td align=\"right\">");
		makebutton("groups", "admingroups.php", 
			   "Group Administration", "large");
		print("</td></tr>");

	    }
	    print("<tr><td></td></tr>");
	}

	print("<tr><td><br><b><big>Customize</big></b></td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("keywords", "keywords.php", "Keywords", "large");
	print("</td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("templates", "templates.php", "templates", "large");
	print("</td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("projects", "projects.php", "projects", "large");
	print("</td></tr>");

	if ($S_STATUS > $G_ADMIN)
	{
	    print("<tr><td align=\"right\">");
	    makebutton("globals", "install.php", "globals", "large");
	    print("</td></tr>");
	}

	print("<tr><td><br><b><big>Session</big></b></td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("profile", "changepwd.php", "settings", "large");
	print("</td></tr>");
	print("<tr><td align=\"right\">");
	makebutton("logout", "index.php?logout=1", "logout", "large");
	print("</td></tr>");

    }  
    // end table with buttons
    print("</table> ");
    // end first column in row two
    print("</td>");
    // start second column in row two
    print("<td valign=\"top\" bgcolor=\"#eeeeef\" width=\"100%\"><br>");
    Debug::printDebug("SORRY, we are debugging. Please ignore the debug messages!");

}

////
// !Prints footer for each page
function printfooter()
{
    global $S_LOGIN;

    // end second column in row two
    print("</td>");
    // end rwo two
    print("</tr>");

    // third row, containing footer
    print("<tr> ");
    print("<td>&nbsp;</td> ");
    print("<td valign=\"middle\">");
    print("<table width=\"100%\" cellpadding=0 cellspacing=0 border=0>");
    print("<tr>");
    print("<td align=\"center\" width=\"90%\">");
    print("&nbsp;");
    print("</td>");
    if (isset($S_LOGIN))
    {
	print("<td align=\"right\" width=\"10%\">");
	makebutton("back%20to%20top", "#top", "back to top", "large");
	print("</td>");
    }
    print("</tr>");
    print("</table>");
    print("</td>");
    print("</tr>");
    print("</table>");

    print("</body>");
    print("</html>");
}

////
// returns a link to a randomly selected image from the designated directory
// imagedir should be relative to the running script and be web-accessible
function randomImage($imagedir) {
   // determine contents of imagedir and store imagefilenames in imagearray
   $dirhandle = opendir ("$imagedir");
   if (!$dirhandle)
      return false;
   $j = 0;
   while ($file = readdir ($dirhandle)) {
      if (strstr ($file, ".png") || strstr($file, ".jpg") ||
                                    strstr($file,".gif") ) {
         $imagearray[$j]=$file;
         $j++;
      }
   }
   $filecount=sizeof ($imagearray);
   // no files
   if (!$filecount)
      return false;
   // 'select' a random file
   srand((double)microtime()*1000000);
   if ($filecount>1)
      $filenr=rand (0,$filecount-1);
   else
      $filenr=0;
   // construct link to randomly selected file
   $filename=$imagearray[$filenr];
   return "<img src='$imagedir/$filename'>\n";
}


// shows meta-data in table
function display_meta_data ($screen) {
  global $fields, $date_format, $sidb_root, $PHPSESSID;

  // make all meta_data variables known
  $fieldname = strtok ($fields,",");
  global $$fieldname;
  while ($fieldname) {
     global $$fieldname;
     $fieldname = strtok (",");
  }

  if ($screen)
     $border = 1;
  else
     $border = 0;
  $echo .= "<table border=$border";
  if ($screen) 
     $echo .= ">\n";
  else
     $echo .= " align=center>\n";
  $echo .= "<colgroup><col valign=top><col>\n";

  // show the database content

  $echo .= "<tr><td>filename</td><td>$filename</td></tr>\n";
  $ownername = get_user_info ($userid, "real_name");
  $ownermail = get_user_info ($userid, "email");
  $echo .= "<tr><td>owner</td><td>
	    <a href=mailto:$ownermail>$ownername</a></td></tr>\n";
  $echo .= "<tr><td>hyperlink</td><td>
	    <a href=\"http://$sidb_root/show.php?id=$imageid&PHPSESSID=$PHPSESSID\">http://$sidb_root/show.php?id=$imageid</a></td></tr>\n";
  if ($description) {
     $description = str_replace ("\n", "<br>\n", htmlentities($description));
     $echo .= "<tr><td valign=top>description</td><td>$description</td></tr>\n";
  }  
  $echo .= "<tr><td>raw data</td><td>";
  if ($raw_data == "t")
     $echo .= "yes";
  else
     $echo .= "no";
  $echo .= "</td></tr>\n";
  if($date_time) {
     $string2 = date("$date_format (H:i)", $date_time);
     $echo .= "<tr><td>upload date</td><td>$string2</td></tr>\n";
  }
  if ($exp_date) {
     $string2 = date ($date_format, $exp_date);
     $echo .= "<tr><td>will be deleted after</td><td>$string2</td></tr>\n";
  } 
  if ($keywords_string = show_keywords ($imageid) )
     $echo .= "<tr><td>keywords: </td><td>$keywords_string</td></tr>\n";
  if ($projectid = get_project ($imageid, "images") ) {
     if (sizeof($projectid) > 0)  {
	$echo .= "<tr><td>project: </td><td>";
	for ($i=0; $i < sizeof($projectid); $i++) {
	   $theid=$projectid[$i];
	   $projectname = get_project_info ($theid, "name");
	   $projectlink = "<a href=\"projects.php?show=true&id=$theid\">";
	   $projectlink .= "$projectname</a>";
	   $echo .= "$projectlink<br>\n";
	}
	$echo .= "</td></tr>\n";
     }
  }

  // display access rights
  $echo .= "<tr><td>can be seen by</td><td>";
 if ($everyone == "t")
     $echo .= "everyone";
  elseif ($restrict_to_group == "t") {
     $groupid = get_user_info ($userid, "groupid");
     $groupname = get_group_info ($groupid, "groupname");
     $echo .= "group: $groupname";
  }
  elseif ($private == "t") {
     $real_name = get_user_info ($userid, "real_name");
     $echo .= "$real_name";
  }
  $echo .= "</td></tr>\n";
  $trust_array=get_trust_array($imageid);
  if ($trust_array && ($everyone <> "t")) {
     $echo .= "<tr><td>and also by</td><td>";
     for ($i=0;$i<sizeof($trust_array);$i++) {
	$trusted = get_user_info ($trust_array[$i], "real_name");
	$echo.= "$trusted<br>";
     }
     $echo.= "</td></tr>\n";
  }

  // file related items
  $echo .= "<tr><td colspan=2>\n";                       
  $echo .= "<table border=$border align=center>\n";     
  $echo .= "<caption><i>File specifications</i></caption>\n"; 

  if ($filesize) {
     $string = nice_bytes ($filesize);
     $echo .= "<tr><td>filesize</td><td>$string</td></tr>\n";
  }
  if ($filetype)
     $echo .= "<tr><td>2-D, 3-D, ICS, or other: </td><td>$filetype</td></tr>\n";
  if ($filetype_extension)
     $echo .= "<tr><td>filetype</td><td>$filetype_extension</td></tr>\n";
  if ($mime)
     $echo .= "<tr><td>mimetype</td><td>$mime</td></tr>\n";
  $echo .= "\n</table>\n";  

  // image related items
  if ( ($filetype == "3-D") || ($filetype == "ICS") ) {
  $echo .= "<tr><td colspan=2>\n";                       
  $echo .= "<table border=$border align=center>\n";     
  $echo .= "<caption><i>Microscope specifications</i></caption>\n";  
     if ($microscope_type)
	if ($scope_string = show_scope ($imageid) )
	   $echo .= "<tr><td>microscope type</td><td>$scope_string</td></tr>\n";
     if ($numaperture)
	$echo .= "<tr><td>n.a. of objective</td><td>$numaperture</td></tr>\n";
     if ($refrinxlensmedium)
	$echo .= "<tr><td>r.i. immersion medium</td><td>$refrinxlensmedium</td></tr>\n";
     if ($refrinxmedium)
	$echo .= "<tr><td>r.i. object</td><td>$refrinxmedium</td></tr>\n";
     $echo .= "\n</table>\n";   
  }

  // voxel/pixel dimensions
  if ($filetype == "2-D" || $filetype=="multipage") {
     if ($x_pixel || $y_pixel)
	$echo .= "<tr><td>number of pixels (x, y)</td><td>$x_pixel x $y_pixel</td></tr>\n";
  }
  if ( ($filetype =="3-D") || ($filetype =="ICS") ) {
     // echo "<tr><td>xyz</td><td>$x_nm,$x_pixel</td></tr>";
     if ($x_nm || $y_nm || $z_nm || $t_sec) {
	$echo .= "<tr><td colspan=2>\n";
	$echo .= "<table border=$border>\n";
	$echo .= "<caption><em>Voxel specifications</em></caption>\n";
	$echo .= "<tr><td>&nbsp</td><th>x</th><th>y</th><th>z</th>";
	// most images have only one-time point.  ugly to show column 't' in all those cases:
	if ($t_sec)
	   $echo .= "<th>t</th>";
	$echo .= "</tr>\n";
	$echo .= "<tr><td>voxel size (nm, sec)</td><td align=right>$x_nm</td><td align=right>$y_nm</td><td align=right>$z_nm</td>";
	if ($t_sec)
	   $echo .= "<td align=right>$t_sec</td>";
	$echo .= "</tr>\n";
	if ($x_pixel || $y_pixel || $z_pixel)
	   $echo .= "<tr><td>number of voxels</td><td align=right>$x_pixel</td><td align=right>$y_pixel</td><td align=right>$z_pixel</td>";
	if ($t_sec)
	   $echo .= "<td>&nbsp</td>";
	$echo .= "\n</table>\n";
     }
  }


  $echo .= "<tr><td colspan=2>\n";
  $echo .= print_channels ($imageid, 1, $screen);
  $echo .= "</td></tr>\n";

  $echo .= "</table>\n";

  return $echo;

}


?>
