<?php

// keyword_inc.php - Interface with functions for keyword managament.
// keyword_inc.php - author: Nico Stuurman 
  /***************************************************************************
  * get_keywordid ($imageid)                                                 *
  * get_keywordid_template ($templateid)                                     *
  * get_keyword ($imageid)                                                   *
  * show_keywords ($imagid)                                                  *
  * show_keywords_column ($imageid)                                          *
  * couple_keyword_to_image ($keywordid, $imageid)                           *
  * couple_keyword_to_template ($keywordid, $templateeid)                    *
  * uncouple_all_keywords_from_image ($imageid)                              *
  * uncouple_all_keywords_from_template ($templateid)                        *
  * get_keyword_group_list ()                                                *
  * get_unused_keywords ()                                                   *
  * make_keyword ($keyword)                                                  * 
  * delete_keyword ($keywordid)                                              *
  * print_keywordbox ($imageid, $multiple, $maxsize)                         *
  * print_group_keywordbox ($message, $multiple, $maxsize, $keyname)         *
  * print_group_keywords ($message, $multiple, $maxsize, $keyname)           *                                            
  ***************************************************************************
  * Created 4-8-2000 by Nico                                                 *
  ***************************************************************************
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: nicost@sidb.sourceforge.net                                       *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                              
////
class key_word_id {
   var $keywordid;
   var $keyword;
}

////
// !returns an array with keywordids given an imageid
function get_keywordid ($imageid) {
   $query = "SELECT keywordid FROM imagexkeywords WHERE imageid=$imageid;";
   //echo "$query <br>";
   $result = db_exec ($query);
   $numrows = db_NumRows ($result);
   //echo "numrows: $numrows <br>";
   if ($numrows==0)
      return false;
   for ($i=0; $i < $numrows; $i++) {
      $keywordid[$i] = db_result($result, $i, "keywordid");
      //echo "keywordid[$i]: $keywordid[$i] <br>";
   }
   return $keywordid;
}

////
// !returns an array with keywordids given an templateid
function get_keywordid_template ($templateid) {
   $query = "SELECT keywordid FROM templatexkeyword WHERE templateid=$templateid;";
   $result = db_exec ($query);
   $numrows = db_NumRows ($result);
   //echo "numrows: $numrows <br>";
   if ($numrows==0)
      return false;
   for ($i=0; $i < $numrows; $i++) {
      $keywordid[$i] = db_result($result, $i, "keywordid");
      //echo "keywordid[$i]: $keywordid[$i] <br>";
   }
   return $keywordid;
}

////
// !returns keyword given a keywordid
function get_keyword ($keywordid) {
   $query = "SELECT keyword FROM keywords WHERE keywordid=$keywordid;";
   $result = db_exec ($query);
   $numrows = db_NumRows ($result);
   if ($numrows==0 || $numrows > 1)
      return false;
   else return db_result($result, 0, "keyword");
}

////
// !returns a string with keywords given an imageid
function show_keywords ($imageid) {
   if ($the_ids=get_keywordid ($imageid) ){
      reset ($the_ids); 
      while (list(, $value) = each ($the_ids)) {
         $string .= trim (get_keyword ($value)) ." ";
      }   
      return $string;
   }
   else return false; 
}


////
// !returns a string with keywords given an imageid
function show_keywords_column ($imageid) {
   if ($the_ids=get_keywordid ($imageid) ){
      $size_keys = count($the_ids);
      reset ($the_ids); 
      if ($size_keys<6) {
	 while (list(, $value) = each ($the_ids)) {
            $string .= get_keyword ($value)."<br>";
         }
      } 
      else {
         $string = "<TEXTAREA rows=5 cols=12 class=\"read_only\">\n";
         while (list(, $value) = each ($the_ids)) {
            $temp = trim (get_keyword ($value));
            $string .= $temp."\n";
         }
         $string .= "</TEXTAREA>\n"; 
      }

      return $string;
   }
   else return false; 
}

////
// !assigns a keywordid to an imageid
function couple_keyword_to_image ($keywordid, $imageid) {
   //first check whether assignment has already been made
   $query = "SELECT keywordid FROM imagexkeywords WHERE imageid=$imageid AND keywordid=$keywordid;";
   $result = db_exec ($query);
   if (db_NumRows ($result) > 0)
      return true;
   $query = "INSERT INTO imagexkeywords VALUES ('$imageid', '$keywordid')";
   if (!$result = db_exec ($query) ) {
      do_error ("Could not add keyword");
      return false;
   }
   return true;
} 

////
// !assigns a keywordid to an templateid
function couple_keyword_to_template ($keywordid, $templateid) {
   //first check whether assignment has already been made
   $query = "SELECT keywordid FROM templatexkeyword WHERE templateid=$templateid AND keywordid=$keywordid;";
   $result = db_exec ($query);
   if (db_NumRows ($result) > 0)
      return true;
   $query = "INSERT INTO templatexkeyword VALUES ('$templateid', '$keywordid')";
   if (!$result = db_exec ($query) ) {
      do_error ("Could not add keyword");
      return false;
   }
   return true;
}

////
// !removes all relations between keywords and this image
function uncouple_all_keywords_from_image ($imageid) {
   $query = "DELETE FROM imagexkeywords WHERE imageid=$imageid;";
   if (db_exec ($query)) 
      return true;
   else 
      return false; 
}

////
// !removes all relations between keywords and this template
function uncouple_all_keywords_from_template ($templateid) {
   $query = "DELETE FROM templatexkeyword WHERE templateid=$templateid;";
   if (db_exec ($query)) 
      return true;
   else 
      return false; 
}

////
// !returns an array with all keywords and keywordids
function get_keyword_list () {
   global $S_USERID;

   $query2 = imgright_query ($S_USERID, "imageid", "images.imageid = imagexkeywords.imageid");
   $query = "SELECT keywordid, keyword FROM keywords ";
   $query .= "WHERE EXISTS (SELECT keywordid FROM imagexkeywords WHERE keywords.keywordid = imagexkeywords.keywordid AND EXISTS ($query2)) ";
   $query .= "ORDER BY keyword;";
   //echo "$query<br>";
   $result = db_exec ($query);
   $numrows = db_NumRows ($result);

   if ($numrows==0)
      return false;
   $keys[] = new key_word_id;
   for ($i=0; $i < $numrows; $i++) {
      $keys[$i]->keyword = db_result($result, $i, 'keyword');
      $keys[$i]->keywordid = db_result ($result, $i, 'keywordid');
   }
   return $keys;
}

////
// !returns an array with group specific keywords and keywordids, given the users groupid
function get_keyword_group_list () {
   global $S_GROUPID;

   // first check whether the group has any keywords at all
   if (!($result=db_exec("SELECT keywordid FROM groupxkeywords WHERE groupid=$S_GROUPID")) )
      return false;

   $query = "SELECT keywordid, keyword FROM keywords WHERE keywordid IN ";
   $query .= "(SELECT keywordid FROM groupxkeywords WHERE groupid=$S_GROUPID) ORDER BY keyword;";
   $result = db_exec ($query);
   $numrows = db_NumRows ($result);

   if ($numrows==0)
      return false;
   $keys[] = new key_word_id;
   for ($i=0; $i < $numrows; $i++) {
      $keys[$i]->keyword = db_result($result, $i, 'keyword');
      $keys[$i]->keywordid = db_result ($result, $i, 'keywordid');
   }
   return $keys;
}

////
// !returns an array with unused keywords and keywordids, given the users groupid
function get_unused_keywords () {
   global $S_GROUPID;

   $query = "SELECT keywordid, keyword FROM keywords WHERE (keywordid NOT IN ";
   $query .="(SELECT keywordid FROM imagexkeywords) ) AND (keywordid IN ";
   $query .= "(SELECT keywordid FROM groupxkeywords WHERE groupid='$S_GROUPID') )";
   $query .= "ORDER BY keyword;";
   $result = db_exec ($query);
   $numrows = db_NumRows ($result);

   if ($numrows==0)
      return false;
   $keys[] = new key_word_id;
   for ($i=0; $i < $numrows; $i++) {
      $keys[$i]->keyword = db_result($result, $i, 'keyword');
      $keys[$i]->keywordid = db_result ($result, $i, 'keywordid');
   }
   $temp = new key_word_id;
   return $keys;
}


////
// !checks if given keyword exists in the current group, when not, a new keyword is created and its id returned
function make_keyword ($keyword){
   global $S_GROUPID;

   //Check whether given keyword exists at all
   $query = "SELECT keywordid FROM keywords WHERE (keyword ='$keyword');";
   $result = db_exec ($query);
   $numrows = db_NumRows($result);

   //the keyword exists, check whether the group has it already
   if ($numrows==1){  
      //first remember the keywordid
      $keywordid = db_result ($result,0,"keywordid");
      //query to check whether the group has the keyword assigned
      $query = "SELECT keywordid FROM keywords WHERE (keyword ='$keyword') AND ";
      $query .= "(keywordid IN (SELECT keywordid FROM groupxkeywords WHERE groupid=$S_GROUPID) );";
      $result = db_exec ($query);
      $numrows = db_NumRows($result);

      //the group did not have it yet, so assign it to the group 
      if ($numrows==0){  
         $query = "INSERT INTO groupxkeywords (groupid,keywordid) VALUES ('$S_GROUPID','$keywordid');";
         $result = db_exec ($query);
      }

      //the group had the keyword assigned already
      elseif ($numrows==1) 
         return (db_result ($result,0,"keywordid") );
      else 
         do_error ("Multiple assignment of the keyword \"$keyword\" to your group exist.  Please report to your sysadmin");
   }

   //the keyword did not exist yet.  Make it and assign to the group
   elseif ($numrows==0) {  
      $query = "INSERT INTO keywords (keyword) VALUES ('$keyword');";
      $result = db_exec ($query);
      // find out which id has been assigned
      $query = "SELECT keywordid FROM keywords WHERE keyword='$keyword';";
      $result = db_exec ($query);
      if (db_NumRows($result)==1)  {
         $keywordid = db_result ($result,0,"keywordid");
         $query = "INSERT INTO groupxkeywords (groupid,keywordid) VALUES ('$S_GROUPID','$keywordid');";
         $result = db_exec ($query);
      }
      else
         return false; 
   }

   // more than one keyword assigned?!
   else    
      do_error ("Multiple assignment of the keyword \"$keyword\" to your group exist.  Please report to your sysadmin");

   //check if it all worked:
   $query = "SELECT keywordid FROM keywords WHERE (keyword ='$keyword') AND ";
   $query .= "(keywordid IN (SELECT keywordid FROM groupxkeywords WHERE groupid=$S_GROUPID) );";
   $result = db_exec ($query);
   if (db_NumRows($result)==1)
      return (db_result ($result,0,"keywordid") );
   else
      return false;  
}



////
// !checks if given keywordid exists, is not used, and 'owned' by the group. Then remove keyword and grouplinks to it
function delete_keyword ($keywordid) {
   global $S_GROUPID;
   
   $query = "SELECT * FROM keywords WHERE (keywordid =$keywordid) ";
   $query .= "AND (keywordid IN (SELECT keywordid FROM groupxkeywords WHERE (groupid=$S_GROUPID) ) )";
   $query .= "AND (keywordid NOT IN (SELECT keywordid FROM imagexkeywords));";
   $result = db_exec ($query);
   $numrows = db_NumRows ($result);  
   if (db_NumRows($result)==1) {
      $test = true;
      db_exec ("BEGIN WORK;");
      $query = "DELETE FROM keywords WHERE keywordid=$keywordid;";
      if (!(db_exec ($query))) $test=false;
      $query = "DELETE FROM groupxkeywords WHERE keywordid=$keywordid;";
      if (!(db_exec ($query))) $test=false;
      $query = "DELETE FROM templatexkeyword WHERE keywordid=$keywordid;";
      if (!(db_exec ($query))) $test=false;
      if ($test) {
         db_exec ("COMMIT WORK;");
         return true;
      }
      else {
         db_exec ("ROLLBACK WORK;");
         return false;
      }
   }
   else return false;
}


////
// !Displays multiple selection box for keywords. 
// Highlights keywords assigned to the image
// Needs to be called from within a form and table
function print_keywordbox ($imageid, $multiple, $maxsize){

   $the_keys[]=new key_word_id;
   $the_keys= get_keyword_group_list();
   $selected_ids = get_keywordid ($imageid);
   $nr_keywords= count($the_keys);
   if ($nr_keywords < 1) return false;
   if ($nr_keywords < $maxsize) 
      $size = $nr_keywords;
   else
      $size = 10;
   echo "<TR><TD valign='top'>Change keywords to</TD>\n";
   echo "<TD><SELECT $multiple size=\"$size\" name=\"keys[]\">";
   for ($i=0; $i<count($the_keys); $i++) {
      $temp = new key_word_id;
      $temp=$the_keys[$i];
      $temp->keyword = trim ($temp->keyword);
      if ($selected_ids)
         if ( in_array ($temp->keywordid, $selected_ids) )
            echo "<OPTION selected value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
         else
            echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
      else
         echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
   }
   echo "</SELECT>";
   echo "</TD>";
}

////
// !Displays multiple selection box for keywords. 
// Needs to be called from within a form and table
/*
function print_group_keywordbox ($message, $multiple, $maxsize, $keyname) {
   $the_keys[]=new key_word_id;
   $the_keys= get_keyword_group_list();
   $nr_keywords= count($the_keys);

   if ($nr_keywords > 0 && $the_keys[0]->keywordid<>0 ) {
      echo "this is print_group_keywordbox.  Remove call!<br>";
      echo "<TR><TD valign='top'>$message</TD>\n";
      if ($nr_keywords < $maxsize) 
         $size = $nr_keywords;
      else
         $size = $maxsize;
      echo "<TD><SELECT $multiple size=\"$size\" name=\"$keyname\">\n";
      for ($i=0; $i<count($the_keys); $i++) {
         //$temp = new key_word_id;
         $temp=$the_keys[$i];
         $temp->keyword = trim ($temp->keyword);
         echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
      }
      echo "</SELECT></TD>\n";
   }
}
*/

////
// !Displays multiple selection box for keywords. 
// Needs to be called from within a form
// Replaces print_group_keywordbox
// When an array with existing keywords is given, these are pre-selected
function print_group_keywords ($message, $multiple, $maxsize, 
                               $keyname, $key_array=false, $norow) {
   $the_keys[]=new key_word_id;
   $the_keys= get_keyword_group_list();
   $nr_keywords= count($the_keys);

   if ($nr_keywords > 0 && $the_keys[0]->keywordid<>0 ) {
      if ($norow)
         echo "<TD ROWSPAN=5 valign='top'>$message<BR>\n";
      else
         echo "<TR><TD>$message</TD>\n";
      if ($nr_keywords < $maxsize) 
         $size = $nr_keywords;
      else
         $size = $maxsize;
      if ($norow)
         echo "<SELECT $multiple size=\"$size\" name=\"$keyname\">\n";
      else
         echo "<TD><SELECT $multiple size=\"$size\" name=\"$keyname\">\n";
      for ($i=0; $i<count($the_keys); $i++) {
         //$temp = new key_word_id;
         $temp=$the_keys[$i];
         $temp->keyword = trim ($temp->keyword);
         // check if keyword was previously selected; if so, display selected
         if ($key_array) {
            if (in_array($temp->keywordid,$key_array)) 
               echo "<OPTION selected value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
            else 
               echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
         }
         else
            echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
      }
      echo "</SELECT></TD>\n";
   }
}

?>
