<?php

//project_inc.php - Functions related to projects.
//project_inc.php - author: Nico Stuurman
  /***************************************************************************
  *                                                                          *
  ***************************************************************************
  *             FUNCTIONS                                                    *
  * display_daughthers ($projectid)                                          *
  * display_project ($projectid)                                             *
  * show_projects ($projectid = false)                                       * 
  * edit_project ($mothersid, $projectid = false)                            *
  * delete_project ($projectid)                                              * 
  * upload_projects_image ($projectid)                                       * 
  * upload_project ($motherid, $projectid=false, $do_modify = false)         * 
  ***************************************************************************
  * Author: Nico Stuurman                                                    *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2001 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/


////
// !Displays all daugtherprojects with hyperlinks
// All accesible top level projects when no id is given
function display_daughters ($projectid) {
   global $PHP_SELF, $S_USERID;

   $showperrow=6;
   $ids = find_projects ($projectid);
   if (is_array($ids)) {
      if ($projectid)
         echo "<hr><h5>Sub-Projects</h5>\n";
      else
         echo "<h5>Top Level Projects</h5>\n";
      echo "<table border=0 valign='top'>\n<tr>";
      for ($i=0; $i < sizeof ($ids); $i++) {
         if (projviewrights ($ids[$i], $S_USERID)) {
            $counter++;
            $name = get_project_info ($ids[$i], "name");
            $id = $ids[$i];
            $link = "<a href=\"$PHP_SELF?show=true&id=$id".'"'. ">";
            echo "<td valign='top' align='center' width='132'>$link $name</a>
                  <br>\n";
            if ($thumb = project_image ($id, "small") ) {
               $bogus = microtime();
               $thumb = "showprojthumb.php?id=$id&size=small&bogus=$bogus";
               $img = "<img border=0 src=$thumb>";
               echo "$link $img </a>";
            }
            echo "</td>";
            if (!($counter%$showperrow))
               echo "\n</tr>\n<tr><td>&nbsp;</td></tr><tr>\n";
         }
      }
      echo "</tr>\n</table>\n";
   }
}

////
// !Displays a specific project
function display_project ($projectid) {
   global $project_fields, $PHP_SELF, $S_USERID, $S_STATUS, $G_GUEST;

   // include code to test whether user may see this
   if (! projviewrights ($projectid, $S_USERID)) {
      echo "Not meant to be seen by you.<br>";
      return false;
   }

   $query = "SELECT $project_fields FROM projects WHERE projectid=$projectid;";
   $result = do_database_query ($query);
   if (db_NumRows ($result) <> 1) 
      return false;
   $data = db_Fetch_Array ($result, 0);

   $name = $data["name"];
   $description = $data["description"];
   $owner = get_user_info ($data["userid"], "real_name");
   $email = get_user_info ($data["userid"], "email");
   $query = "SELECT motherid FROM projectxprojects WHERE daughterid=$projectid";
   $result2 = do_database_query ($query);
   
   // provide the 'up' link
   $test = false;
   if (db_NumRows ($result2) > 0) {
      $data2 = db_Fetch_Array ($result2, 0);
      if ($motherid = $data2["motherid"]) {
         if (projviewrights ($motherid, $S_USERID)) {
            $mothersname = get_project_info ($motherid, "name");
            echo "<a href=\"$PHP_SELF?show=true&id=$motherid\">Up 
                  (to $mothersname)</a>\n<hr>\n";
            $test = true;
         }
      }
   }
   if (! $test)
      echo "<a href=\"$PHP_SELF\">Up (to top)</a>\n<hr>\n";
   
   echo "<table>\n";
   echo "<tr><td align='center' valign='top'><h3>$name</h3></td>";
   if ($thumb = project_image ($projectid, "small") ) {
      $bogus = microtime ();
      $thumb = "showprojthumb.php?id=$projectid&size=big&random=$bogus";
      $thumb = "<img border=0 src=$thumb>";
   }
   echo "<td rowspan=3>$thumb</tr>\n";
   echo "<tr><td align='center' valign='top'>by <i><a href='mailto:$email'>
         $owner</a></i></td></tr>";
   echo "<tr><td width=50% valign='top'>$description</td></tr>";
   echo "</table>\n";

   // Provide links to edit/delete the project and to create daughters
   $rights = projrights($projectid);
   if ($rights || $S_STATUS > $G_GUEST) {
      echo "<hr>\n<table>\n<tr>\n";
      echo "   <td width=15%><h4>Action</h4></td>\n";
      echo "<form name='show_project' method='post' action='$PHP_SELF'>\n";
      echo "<input type='hidden' name='id' value='$projectid'>\n";
      if ($motherid)
         echo "<input type='hidden' name='motherid' value='$motherid'>\n";
      if ($rights) {
         echo "<td width=15%><input type='submit' name='edit' value='Edit'>
               </td>\n";
         echo "<td width=15%><input type='submit' name='delete' value='Delete'
            Onclick=\"if(confirm('Do you really want to delete this project?'))
            {return true}return false\"></td>\n";
      }
      if ($S_STATUS > $G_GUEST)
         echo "<td width=15%><input type='submit' name='create_project' 
            value='Create Sub-Project'></td>\n"; 
      echo "</form></table><hr>\n";
   }
   // send the projectid argument as an array
   echo "<table>\n<tr>\n";
   echo "<td width=15%><h4>Show images</h4></td>\n";
   $proj_array[0] = $projectid;
   $s_array = urlencode (serialize($proj_array));
   echo "<form method='post' action='search.php?serial_projarray=$s_array'>\n";
   echo "<td width=15%><input type='submit' name='Images' value='This Project'>
         </td></form>\n";
   $desc = find_desc_projects($projectid);
   $desc[] = $projectid;
   $s_array = urlencode(serialize($desc));
   echo "<form method='post' action='search.php?serial_projarray=$s_array'>\n";
   echo "<td width=15%><input type='submit' name='Images' ";
   echo "value='Include All Sub-Projects'></td></form>\n";
   echo "</tr></table>\n";
   display_daughters ($projectid);
   echo "<hr>\n";
}
 
////
// !shows the projects data
// when no id is given, all top-level projects (from the users perspective)
//  are displayed.
function show_projects ($projectid = false) {
   global $PHP_SELF;

   // when we are at the top level (no $project_id) new top-level projects can
   //  be made
   if (!$projectid) {
      display_daughters (false);
      echo "<hr>\n";
      echo "<form name='project_form' method='post' action=\"$PHP_SELF\">\n";
      echo "<input type='submit' name='new_project' value='New Project'>
            </input>\n";
      echo "</form>\n";
   
   }
   else
      display_project ($projectid);
}

////
// !shows a form for projects data
// when projectid is false, this is a new project 
function edit_project ($motherid, $projectid = false) {
   global $PHP_SELF, $HTTP_POST_VARS, $project_fields;

   if ($projectid && (! projrights($projectid)) ) {
      echo "You are not allowed to change this project.";
      return false;
   }

   $resubmit = $HTTP_POST_VARS["resubmit"];
   if ($resubmit) {
      $fieldname = strtok ($project_fields, ",");
      while ($fieldname) {
         if (! $$fieldname)
            $$fieldname = $HTTP_POST_VARS[$fieldname];
         $fieldname = strtok (",");
      }
   }

   // translate viewrights into rights
   if ($viewrights = $HTTP_POST_VARS["viewrights"]) {
      switch ($viewrights) {
         case "private": $rights = 1; break;
         case "restrict_to_group": $rights = 2; break;
         case "everyone": $rights = 4; break;
      }
   }

   echo "<form enctype='multipart/form-data' name='project_edit_form' 
           method='post' action=\"$PHP_SELF\">\n";
   echo "<input type='hidden' name='resubmit' value='true'>\n";
   if ($motherid)
      echo "<input type='hidden' name='motherid', value=\"$motherid\">\n";
   if ($projectid && !$resubmit) {
      echo "<input type='hidden' name='projectid', value=\"$projectid\">\n";
      // pull data from database
      $query = "SELECT $project_fields FROM projects WHERE 
                      projectid=$projectid;";
      $result = do_database_query ($query);
      $row = db_Fetch_Array ($result, 0);
      $fieldname = strtok ($project_fields, ",");
      while ($fieldname) {
         $$fieldname = $row[$fieldname];
         $fieldname = strtok (",");
      }
      switch ($rights) {
         case 1: $viewrights = "private"; break;
         case 2: $viewrights = "restrict_to_group"; break;
         case 4: $viewrights = "everyone"; break;
      }
   }
   echo "<table>\n";
   echo "<tr><td>Project Name</td>\n";
   echo "<td><input type='text' size='20' name='name' value='$name'>";
   echo "</input></td>\n";
 
   if ($thumb = project_image ($projectid, "small") ) {
      $bogus = microtime ();
      $thumb = "showprojthumb.php?id=$projectid&size=big&random=$bogus";
      $thumb = "<img border=0 src=$thumb>";
   }
   echo "<td colspan=3 rowspan=4>$thumb</td>\n"; 

   echo "</tr>\n";
 
   echo "<tr><td>Image file<br>(optional)</td>\n";
   echo "<td><td><input type='file' name='location' value=\"$location\"></td>";
   echo "</tr>\n";
  
   echo "<tr><td colspan=2><h4>Who may see this project?</h4></td></tr>\n";

   // set who may see the project.  Use an array to loop through the possibilies
   $bool = array ("private","restrict_to_group", "everyone");

   // set default viewright to 'group only'
   if (! $viewrights)
      $viewrights = "restrict_to_group"; 

   // loop trough the array to display
   for ($i= 0; $i < 3; $i++) {
      $fieldname = $bool[$i];
      echo "<tr><td>".translate($fieldname). "</td><td>
            <input type ='radio' name='viewrights' value='$fieldname'";
      if ($viewrights == $fieldname) {
         echo "checked value ='on'";
      }
      echo "></td></tr>\n";
   }

   echo "<tr><td>Description</td>\n";
   echo "<td colspan=5><textarea name='description' rows='6'cols='50'>";
   echo "$description</textarea></td></tr>";

   echo "</table>\n";

   echo "<input type='submit' name='submit_project' value='Submit'>\n";
   echo "</form>\n";
}

////
// !Name says it all
function delete_project ($projectid) {
   global $S_USERID;

   if (! $projectid ||  ! projrights($projectid) )
      return false;

   // add whole lot of security stuff here

   // No go when there still are sub-projects
   $query = "SELECT daughterid FROM projectxprojects WHERE 
             motherid='$projectid';";
   $result = do_database_query ($query);
   $count = db_NumRows ($result);
   if ($count > 0) {
      if ($count == 1)
         echo "<h4>There is one Sub-Project of this project.  
               Please delete it first.</h4>\n";
      else
         echo "<h4>There are $count Sub-Projects of this project.  
               Please delete those first.</h4>\n";
      return $projectid;
   }

   do_database_query ("BEGIN WORK");
   $query = "DELETE FROM projectxprojects WHERE motherid=$projectid";
   do_database_query ($query);
   $query = "DELETE FROM projectxprojects WHERE daughterid=$projectid";
   do_database_query ($query);
   $query = "DELETE FROM projects WHERE projectid=$projectid";
   do_database_query ($query);
   do_database_query ("COMMIT WORK");
}

////
// !Name says it all
function upload_projects_image ($projectid) {
   global $convert_path, $default_thumb_size, $min_thumb_size;
   global $thumbnail_dir, $HTTP_POST_FILES;

   $location = $HTTP_POST_FILES["location"]["tmp_name"];

   if (!$projectid || !$location)
      return false;
   if (is_uploaded ($location) )  { 
      $big = "$thumbnail_dir/projects/big/$projectid.jpg";
      $bigsize = 2 * $min_thumb_size;
      $small = "$thumbnail_dir/projects/small/$projectid.jpg";
      $command = "$convert_path -sample " . $bigsize . "x" . 
                  $bigsize . " $location $big";
      $result = `$command`;
      $command = "$convert_path -sample " . $min_thumb_size . "x" . 
                  $min_thumb_size . " $location $small";
      $result = `$command`;
   }
}

////
// !interprets edit_project's output and writes it to database
function upload_project ($motherid, $projectid=false, $do_modify = false) {
   global $project_fields, $HTTP_POST_VARS, $S_USERID;

   // check whether a name was entered
   if (! ($name = $HTTP_POST_VARS["name"]) ) {
      echo "<h3>Please enter a <i>Project Name</i> and try again.</h3>";
      edit_project ($motherid, $projectid);
      return false;
   }

   // check whether name was used before
   $query = "SELECT name FROM projects WHERE name='$name'";
   if ($projectid)
      $query .= " AND projectid!=$projectid";
   $result = do_database_query ($query);
   if (db_NumRows ($result) > 0) {
      echo "<h3>The name <i>$name</i> has already been used. ";
      echo "Please select another name.</h3>\n";
      edit_project ($motherid, $projectid);
      return false;
   }
      
   // translate viewrights into rights
   if ($viewrights = $HTTP_POST_VARS["viewrights"]) {
      switch ($viewrights) {
         case "private": $rights = 1; break;
         case "restrict_to_group": $rights = 2; break;
         case "everyone": $rights = 4; break;
      }
   }

   $userid = $S_USERID;

   // when projectid is known do UPDATE, otherwise INSERT
   if (! $projectid) {
      $query1 = "INSERT INTO projects (";
      $query2 = ") VALUES (";
   }
   else 
      $query1 = "UPDATE projects SET ";

   $test = true;
   $fieldname = strtok ($project_fields, ",");
   while ($fieldname) {
      if (! $$fieldname)
         $$fieldname = $HTTP_POST_VARS[$fieldname];
      if ($fieldname != "projectid") {
         if ($test) { //first time without comma
            $test = false;
            if ($projectid)
               $query1 .= $fieldname ."='". $$fieldname."'";
            else {
               $query1 .= "$fieldname";
               $query2 .= "'" . $$fieldname . "'";
            }
         }
         else {      
            if ($fieldname != "projectid")
               if ($projectid)
                  $query1 .= ", " . $fieldname ."='". $$fieldname."'";
               else {
                  $query1 .= ", $fieldname";
                  $query2 .= ", '" . $$fieldname . "'";
               }
         }
      }
      $fieldname = strtok (",");
   }
   if ($projectid)
      $query = $query1 . " WHERE projectid=$projectid;";
   else
      $query = $query1 . $query2 . ")";

   db_exec ("BEGIN WORK");
   do_database_query ($query);

   if (! $projectid) {
      // determine projectid
      $query = "SELECT projectid FROM projects WHERE name='$name' AND
                userid=$userid";
      $result = do_database_query ($query);
      if (db_NumRows($result) <> 1) {
         echo "Error inserting this project into the database!";
         return false;
      }
      $row = db_Fetch_Array ($result, 0);
      $projectid = $row["projectid"];
   }      
   // and insert relation into the db
   if ($motherid) {
      $query = "INSERT INTO projectxprojects VALUES ($motherid, $projectid)";
      do_database_query ($query);
   }

   db_exec ("COMMIT WORK");

   upload_projects_image ($projectid);

   return $projectid;
}
?>
