<?php

// template_inc.php - Functions to work with templates
// template_inc.php - author: Nico Stuurman
  /***************************************************************************
  * Contains all functions dealing with templates.                           *
  *                                                                          *
  * ************************************************************************ *
  * show_template_form ($filetype, $uploadtype, $new_modify, $templateid)    *
  * make_the_template ($query, $templatename, $keys) {global $S_USERID;      *
  * make_template_query () {global $S_USERID, $template_fields;              *
  * delete_template($templateid)                                             *
  * exist($templatename)                                                     *
  * gettemplateid($templatename)                                             *
  * modify_template ($templateid)                                            *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: nicost@sidb.sf.net                                                *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                          



$template_fields = "templateid,userid,templatename,description,raw_data,";
$template_fields .= "private,restrict_to_group,everyone,filetype,";
$template_fields .= "trust,microscope_type,channels,";
$template_fields .= "refrinxmedium,refrinxlensmedium,numaperture,";
$template_fields .= "x_nm,y_nm,z_nm,t_sec,x_thumb,y_thumb,fs_thumb,exp_period,";
$template_fields .= "pinsize,pinspacing";



function show_template_form ($filetype, $uploadtype, $new_modify, 
                             $templateid=false) {
   global $PHP_SELF, $IMAGE_TOOLS, $template_fields, $scope, $fs, $projects;
   global $trust_array, $viewrights, $keys, $nr_channels, $exp_number;
   global $exp_never_box, $exp_unit, $resubmit;

   ?>
<H2>Template</H2><BR>
<FORM enctype="multipart/form-data" METHOD="post" NAME="templateform" ACTION="<?PHP echo $PHP_SELF; ?>" >
<INPUT TYPE="hidden" NAME="filetype" VALUE="<?PHP echo $filetype ?>">
<INPUT TYPE='hidden' NAME='resubmit' VALUE='true'>
<INPUT TYPE='hidden' NAME='new_modify' VALUE='<?php echo $new_modify ?>'>
<INPUT TYPE='hidden' NAME='uploadtype' VALUE='<?php echo $uploadtype ?>'>
<?php
   if (templateid) 
      echo "<INPUT TYPE='hidden' NAME='templateid' VALUE=\"$templateid\">\n";
   echo "<TABLE>\n";

   // 'read' in all global variables, wherever they come from
   $fieldname = strtok ($template_fields,",");
   global $$fieldname;
   $fieldname_value = $$fieldname;
   $i = 0;
   while ($fieldname) {
      $fieldname = strtok (",");
      global $$fieldname;
      $fieldname_value = $$fieldname;
   }

   if ($templateid) 
      $projectid = get_project ($templateid, "template"); 
   
   if ($resubmit) {
      if ($exp_never_box)
         $exp_period = 0;
      else
         $exp_period = $exp_number * $exp_unit;

      //determine microscope_type
      $microscope_type = get_array_value ($scope);
      //determine thumbnail movie frame rate 
      $fs_thumb = get_array_value ($fs);
      //determine trusted user
      $trust = get_array_value ($trust_array);
      // determine selected project
      $projectid = $projects;
   }

   // strip slashes from description to be sure they will not 
   // propagate inadvertently
   $description = stripslashes ($description);

   // display the form, the first part is common to all filetypes
   echo "<TR><TD>".translate("templatename"). "</TD><TD>
         <input type ='TEXT' name='templatename' value='".$templatename."'>
         </TD></TR>\n";
   echo "<TR><TD valign='top'>".translate("description"). "</TD><TD COLSPAN=5>
         <TEXTAREA NAME='description' ROWS='8' COLS='50'>" . $description . 
         "</TEXTAREA></TD></TR>\n"; 
   echo "<TR><TD>".translate("raw_data"). "</TD><TD>
         <input type ='checkbox' name='raw_data' ";
   if ($raw_data && $raw_data != "f")
      echo "checked value = 'on'";
   echo ">";
   print_exp_date_templ($exp_period);
   echo "</TD></TR>\n";
   echo "</TABLE><HR><TABLE>\n";

   echo "<TR><TD><H4>Who may see this image?</H4></TD><TD></TD><TD></TD>";

   print_group_keywords ("<H4>Keywords</H4>", "multiple", 7, "keys[]", 
                         $keys, true);
   
   box_projects ($projectid, "<h4>Project</h4>", false, "projects[]", true);
   echo "</TR>\n";

   // set who may see the image.  Use an array to loop through the possibilies
   $bool = array ("private","restrict_to_group", "everyone");

   // set default viewright to 'group only'
   if ( !($viewrights)  && !( ($private == "t") || 
         ($restrict_to_group == "t") || ($everyone == "t") ) )
      $restrict_to_group = "t";  

   // loop trough the array to display
   for ($i= 0; $i < 3; $i++) {
      $fieldname = $bool[$i];
      $fieldname_value = $$fieldname;
      echo "<TR><TD>".translate($fieldname). "</TD><TD>
            <input type ='radio' name='viewrights' value='$fieldname'";
      if ( (($fieldname_value) && ($fieldname_value !="f")) || 
            ($viewrights == $fieldname) ) {
         echo "checked value ='on'";
      }
      echo "></TD></TR>\n";
   }

   // displays a listbox with all users 
   box_users ($trust,"and also:");

   $box_html = "size=10";

   echo "</TABLE>\n";
   echo "<HR>\n";
   if ($filetype=="2-D" || $filetype=="multipage") {
      echo "<TABLE>\n";
      echo "<TR><TD><H5>Pixelsize (nm)</H5></TD>\n";
      echo "<TD>&nbsp &nbsp x </TD>";
      echo "<TD><input type ='TEXT' name='x_nm' value='$x_nm' 
                 tabindex=400 $box_html></TD>\n";
      echo "<TD>&nbsp &nbsp y </TD>";
      echo "<TD><input type ='TEXT' name='y_nm' value='$y_nm' 
                 tabindex=400 $box_html></TD>\n";
      echo "</TR></TABLE>\n<HR>\n";
   } 
   echo "<TABLE>\n";
   echo "<TR><TD COLSPAN=4 align='left'><H5>Thumbnail size (pixels)</H5></TD>
         </TR>\n";
   echo "<TR><TD>x thumbnail size</TD>";
   echo "<TD><input type='TEXT', name='x_thumb', value='$x_thumb' $box_html>
         </TD>\n";
   echo "<TD>y thumbnail size</TD>";
   echo "<TD><input type='TEXT', name='y_thumb', value='$y_thumb' $box_html>
         </TD>\n";
   if ( ($filetype=="multipage") || ($IMAGE_TOOLS && ($filetype=="3-D" || $filetype=="ICS"))) 
      print_fs_thumb ($fs_thumb);
   echo "</TR>\n";
   echo "</TABLE>\n";
   echo "<HR>\n"; 

   // show the following fields only when 3-D is requested
   if ($IMAGE_TOOLS && ($filetype=="3-D" || $filetype=="ICS")) {
      echo "<TABLE>\n";
      echo "<TR><TD COLSPAN=2><H5>Geometry (nm, sec)</H5></TD></TR>";
      echo "<TR>";
      echo "<TD>x sample size</TD>";
      echo "<TD><input type ='TEXT' name='x_nm' value='$x_nm' $box_html>
            </TD>\n";
      echo "<TD>y sample size</TD>";
      echo "<TD><INPUT TYPE ='TEXT' NAME='y_nm' VALUE='$y_nm' $box_html>
            </TD></TR>\n";
      echo "<TR><TD>z sample size</TD>";
      echo "<TD><INPUT TYPE ='TEXT' NAME='z_nm' VALUE='$z_nm' $box_html>
            </TD>\n";
      echo "<TD>t sample interval</TD>";
      echo "<TD><INPUT TYPE ='TEXT' NAME='t_sec' VALUE='$t_sec' $box_html>
            </TD></TR>\n";       
      echo "</TABLE>\n";
      echo "<HR>\n";

      echo "<TABLE cellspacing='0' border='0'>\n";
      $color_pars = "bgcolor=\"#FFEE88\"";
      $color_ri = "bgcolor=\"#FFBBFF\"";
      $color_pin = "bgcolor=\"#FFDD33\"";
      echo "<TR><TD COLSPAN=2 $color_pars><H5>Optical parameters</H5></TD>
            <TD $color_pars>&nbsp&nbsp&nbsp</TD><TD $color_ri>&nbsp</TD>";
      echo "<TD $color_ri><H5>Refractive indexes</H5></TD>\n";
      echo "<TD $color_pin>&nbsp;</TD>\n";
      echo "<TD $color_pin><H5>Pinhole(s)</H5></TD></TR>\n"; 
      print_microscopes($microscope_type, false, $color_pars);
      echo "<TD $color_pars>&nbsp;&nbsp;&nbsp;</TD>\n";
      echo "<TD $color_ri>&nbsp;&nbsp; Lens</TD><TD $color_ri>
            <INPUT TYPE ='TEXT' NAME='refrinxlensmedium' 
             VALUE='$refrinxlensmedium' SIZE=15></TD>\n";
      echo "<TD $color_pin>&nbsp;&nbsp; Size (nm)</TD><TD $color_pin>
            <INPUT TYPE ='TEXT' NAME='pinsize' 
             VALUE='$pinsize' SIZE=15></TD>\n</TR>\n";
      echo "<TD $color_pars>Numerical aperture</TD><TD $color_pars>
            <INPUT TYPE ='TEXT' NAME='numaperture' VALUE='$numaperture' SIZE=15>
            </TD>\n";
      echo "<TD $color_pars>&nbsp&nbsp&nbsp</TD>\n";
      echo "<TD $color_ri>&nbsp&nbsp Medium</TD><TD $color_ri>
            <INPUT TYPE ='TEXT' NAME='refrinxmedium' VALUE='$refrinxmedium' 
             SIZE=15></TD>\n";
      echo "<TD $color_pin>&nbsp;&nbsp; Spacing (um)</TD><TD $color_pin>
            <INPUT TYPE ='TEXT' NAME='pinspacing' 
             VALUE='$pinspacing' SIZE=15></TD>\n</TR>\n";
      echo "</TABLE>\n";

      if ($new_modify=="new")
         print_channel_form (false, 2);
      else
         print_channel_form ($templateid, 2);
   }

   if ($new_modify == "new")
      echo "<INPUT TYPE='submit' NAME='add' VALUE='Add template' 
             onClick='return checkinput()'>\n";
   elseif ($new_modify == "modify")
      echo "<INPUT TYPE='submit' NAME='modify' VALUE='modify template' 
             onClick='return checkinput()'>\n";
   else
      echo "Error in code!<br>";
     
   echo "</FORM>\n";
}

// write the query to the database
function make_the_template ($query, $templatename, $keys) {
   global $S_USERID, $projects;
   
   db_exec ("BEGIN WORK;");
   $test = true;
   if (db_exec($query)) {
      // figure out the templateid
      $search = db_exec ("SELECT templateid FROM template WHERE 
                      templatename='$templatename' AND userid ='$S_USERID';");
      $r = db_fetch_array($search,0);
      $templateid = $r["templateid"];

      if ($keys) {
         // delete existing keywords
         uncouple_all_keywords_from_template ($templateid);
         // add the new ones
         reset ($keys); 
         while (list(, $value) = each ($keys)) {
            if (! (couple_keyword_to_template ($value, $templateid)) ) 
               $test=false;
         }
      }

      // when no keywords have been chosen, be certain and delete any if present
      else uncouple_all_keywords_from_template ($templateid);

      // add channels 
      if (! (store_channels ($templateid, 2)) )
          $test = false;

      // reset projects, insert newif any
      $query = "DELETE FROM projectxtemplate WHERE templateid=$templateid";
      do_database_query ($query);
      $projectid = $projects;
      if ($projectid) {
         for ($i=0; $i<sizeof($projectid); $i++) {
            $query = "INSERT INTO projectxtemplate VALUES 
                      ('$projectid[$i]','$templateid')";
            if (! do_database_query ($query) )
               $test = false;
         }
      } 
   }
   else $test = false;
   
   // when all went allright:
   if ($test) {
      db_exec ("COMMIT WORK;");      
      echo "Your template has been created/modified";
      return true;
   }
   else {
      db_exec ("ROLLBACK WORK;");
      echo "Something went wrong, please try again";
      return false;
   }
}


// makes query to create/change a template
// do_modify= false for new templates,true for modifications
function make_template_query ($do_modify = false) {
   global $S_USERID, $template_fields, $scope, $fs, $trust_array, $viewrights;
   global $nr_channels, $default_thumb_size, $max_thumb_size, $min_thumb_size;
   global $exp_number, $exp_unit, $exp_never_box;

   //build the SQL statement to insert the template into the database

   //determine microscope_type
   $microscope_type = get_array_value ($scope);
   if (!isset($microscope_type))
      $microscope_type=0;
   //determine thumbnail movie frame rate 
   $fs_thumb = get_array_value ($fs);
   if (!isset($fs_thumb))
      $fs_thumb=0;
   //determine trusted user
   $trust = get_array_value ($trust_array);

   if ($exp_never_box)
      $exp_period = 0;
   else
      $exp_period = $exp_number * $exp_unit;

   switch ($viewrights) {
      case "private":
         $private ="t"; $restrict_to_group = "f"; $everyone= "f";
         break;
      case "restrict_to_group":
         $private = "f"; $restrict_to_group = "t"; $everyone = "f";
         break;
      case "everyone":
         $private = "f"; $restrict_to_group = "f"; $everyone = "t";
         break;
   }

   if ($do_modify)
      $querydeel1 = "UPDATE template SET ";
   else {
      $querydeel1 = "INSERT INTO template (userid";
      $querydeel2 = ") VALUES (".$S_USERID;
   }

   $fieldname = strtok ($template_fields,",");
   while ($fieldname) {
      if ($fieldname != "microscope_type" && $fieldname != "private" 
          && $fieldname != "restrict_to_group" && $fieldname != "fs_thumb"  
          && $fieldname != "everyone" && $fieldname != "trust" 
          && $fieldname != exp_period )
         global ${$fieldname};
      $fieldname_value = ${$fieldname};

      // check types of numeric fields and change when needed
      if ($fieldname == "channels" || $fieldname == "x_thumb" 
                                   || $fieldname == "y_thumb") 
         $fieldname_value = (int) $fieldname_value;
      if ($fieldname == "x_thumb" || $fieldname == "y_thumb") {
         $fieldname_value = trim ($fieldname_value);
         if (!($fieldname_value))
            $fieldname_value = $default_thumb_size;
         else {
            if ($fieldname_value > $max_thumb_size)
               $fieldname_value = $max_thumb_size;
            if ($fieldname_value < $min_thumb_size)
               $fieldname_value = $min_thumb_size;
         }
      }
      if  ($fieldname == "refrinxmedium" || $fieldname == "numaperture" 
           || $fieldname == "refrinxlensmedium" 
           || $fieldname == "x_nm" || $fieldname == "y_nm" 
           || $fieldname == "pinsize" || $fieldname == "pinspacing" 
           || $fieldname == "z_nm" || $fieldname == "t_sec") 
         $fieldname_value = (float) $fieldname_value;

      $fieldname_value = trim ($fieldname_value);


      // Add non-empty fields.  Also add empty/zero numeric fields 
      // Otherwise, these can never be reset to 0
 //     if ( ! (($fieldname_value == "") || ($fieldname_value == " ") 
 //            || ($fieldname == "userid") || ($fieldname == "templateid") ) ) {         
      if (!  ($fieldname == "userid" || $fieldname == "templateid") ) {         
         // sort out the booleans

         if ($fieldname=="raw_data") {
            if ($fieldname_value=="on") 
               $fieldname_value = "t";
            else 
               $fieldname_value = "f";
         }

         if ($do_modify) 
            $querydeel1 .= " $fieldname='$fieldname_value',";
         else {
            $querydeel1 = $querydeel1 .",". $fieldname ;
            $querydeel2 = $querydeel2 .",'". $fieldname_value."'" ;
         }
      }
      $fieldname = strtok (",");
   }
 
   if ($do_modify) 
      // there is a comma to much at the end of querydeel1
      $query = substr ($querydeel1, 0, -1) . " WHERE templateid=$templateid;";
   else 
      $query = $querydeel1.$querydeel2 .");";
   
   // echo "$query<Br>"; 
   return $query;      
}



// function that deletes a choosen template
function delete_template($templateid) {

   // set database query and get result
   $db_query = "SELECT templatename, userid FROM template WHERE 
                templateid='$templateid'";
   $db_result = do_database_query($db_query);
   $db_rows = db_numrows($db_result);

   //check if the templateid exists
   if ($db_rows == 1) {
      $db_row_result = db_fetch_array($db_result, 0);
      $templatename = $db_row_result["templatename"];

      //check for the rights
      if ($S_USERID == $userid){
         db_exec ("BEGIN WORK;");
         // remove associated keywords
         if (uncouple_all_keywords_from_template ($templateid))
            if (do_database_query("DELETE FROM template WHERE templateid='$templateid'")){
               do_database_query ("COMMIT WORK;");
               return "<p>Template $templatename has been deleted!</p>";
            }
         // when still here, it must have failed:
         do_database_query ("ROLLBACK WORK;");
         return "<p>Template $templatename could not be deleted!</p>";
      }
      else
         return "<p>You do not have the rights to delete this template!</p>";
   }      
   else
      return "<p>Template does not exist, so can not be deleted!</p>";
}


// checks whether a templatename is already used, if so, templateid is returned
function exist($templatename) {
   global $S_USERID;

   //Check if templatename already exists.
   $result = do_database_query("SELECT templateid FROM template WHERE 
                      templatename = '$templatename' AND userid ='$S_USERID';");
   $number=db_numrows($result);
   if ($number) {
      $a = db_fetch_array($result,0);
      if($number==0)
	 return false;
      else
	 return $a["templateid"];
   }
   else return false;
}


// returns templatid given a tenplates name
function gettemplateid($templatename) {
   global $S_USERID;
   $result = do_database_query("SELECT templateid FROM template WHERE 
                      templatename='$templatename' AND userid='$S_USERID';");
   $a = db_fetch_array($result, 0);
   return $a["templateid"];
}


// Modifies template data.
// Shows the modify template form and executes the query after submission of
//   the form.
function modify_template ($templateid) {
   global $HTTP_POST_VARS, $S_USERID, $PHP_SELF, $keys, $template_fields;
   global $modify, $default_thumb_size, $max_thumb_size, $min_thumb_size;
   global $exp_never_box, $exp_unit, $exp_number;

   // check if script is called from submit button
   if ($modify) {

      // remove white space around name
      $templatename = $HTTP_POST_VARS["templatename"]; 
      $templatename = trim ($templatename);
      // and check whether the name has been used already
      $query2 = "SELECT templateid FROM template WHERE 
         templatename = '$templatename' AND userid ='$S_USERID' AND 
         templateid <> $templateid;";
      $testquery = do_database_query($query2);
      $number=db_numrows($testquery);

      if ($number>0) {
         $error="double";
         echo "<H2>You used this templatename before.<br> 
                   Please choose another name.</H2>";
      }
      //Check if a templatename has been filled in.
      elseif ($templatename == "") {
	  $error ="empty";
	  echo "<H2>Please enter a templatename</H2>";
      }
      else {
         $query = make_template_query (true);
         make_the_template ($query, $templatename, $keys);
      }
   }


   // show the form with values from database or previously entered
   if (($error) || !($modify)) {

      // read data from database
      $query = "SELECT $template_fields FROM template WHERE 
                templateid = '$templateid' AND userid = '$S_USERID';";
      $result = do_database_query($query);
      $numberofcols = db_numfields($result);

      if ($templateid)
	 $value = db_fetch_array($result,0);
      
      // make variables known globally
      for ($i = 0 ; $i <$numberofcols; $i++) {
	 $fieldname = db_fieldname($result, $i);
         global $$fieldname;
	 if (!($resubmit))
            $$fieldname = $value[$fieldname];
         else
            $$fieldname = $HTTP_POST_VARS[$fieldname];
      }
 
      // get keywords
      if (!($keys) && $templateid)
	 $keys = get_keywordid_template ($templateid);

      show_template_form ($filetype, $uploadtype, "modify", $templateid);
   }
}


?>
