<?php

// search.php - Controls the 'search database' part.
// search.php - author: Nico Stuurman <nicost@sourceforge.net>
  /***************************************************************************
  * This file controls the search part.                                      *
  * ------------------------------------------------------------------------ *
  *            FUNCTIONS                                                     *
  * function get_dir_size ($dir) {                                           *
  * function printsearchresult($result)                                      *
  * function get_dir_size ($dir) {                                           *
  * function show_gallery ($result, $columns, $size)                         *
  * function show_gallery_selected ($columns, $size, $selarray)              *
  * function savesearchresult ($result, $selarray) {                         *
  * function delete_selected ($result, $selarray) {                          *
  * function printbuttons ()                                                 *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  *   Some modifications by jose@svi.nl, 2005                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                                                                           
global $PHPSESSID;

// Includes calls
require("include.php");
require ($include_dir."/show_print_inc.php");

// register variables
$arg_string = "action,number_of_visible_results,loginname,trust,audit,";
$arg_string .= "file_name,file_id,des_cription,period_nr,period,restart,";
$arg_string .= "date_comparison,date_day,date_month,date_year,keybool,";
$arg_string .= "serial_selarray,serial_projarray,audit,showopt,";
$arg_string .= "namebool,sortby, searchtype, file_x, file_y, file_z";
$arg_string .= "file_thumbx, file_thumby, file_thumbt, file_samplex,";
$arg_string .= "file_sampley, file_samplez, file_samplet, file_NA, file_lri";
$arg_string .= "file_mri, file_numchan, file_inchan, file_ex, file_em,";
$arg_string .= "file_photon, file_ph, microscope, file_color, file_raw";

$get_string = $arg_string .", keywrds,keys,trust_array,audit_array";

globalize_vars ($get_string, "HTTP_GET_VARS");
if ($serial_projarray) 
   $project_array = unserialize (stripslashes($serial_projarray));

$post_string = "gallery,printgallery,number_of_visible_results,nr_columns,";
$post_string .= "max_size,allsel,deconv_selected,deconv_all,";
$post_string .= "next,prev,save,save_sel,remove_selected,remove_all,submit,";
$post_string .= "file_name,file_id,des_cription,period_nr,period,";
$post_string .= "date_comparison,date_day,date_month,date_year,keybool,keys,";
$post_string .= "reset,loginname,showopt,";
$post_string .= "namebool,sortby, searchtype, file_x, file_y, file_z,";
$post_string .= "file_thumbx, file_thumby, file_thumbt, file_samplex,";
$post_string .= "file_sampley, file_samplez, file_samplet, file_NA, file_lri,";
$post_string .= "file_mri, file_numchan, file_inchan, file_ex, file_em,";
$post_string .= "file_photon, file_ph, microscope, file_color, file_raw,";
$post_string .= "action,start,serial_selarray,checkarray,trust_array,audit,";
$post_string .= "audit_array,audit,project_array";

globalize_vars ($post_string, "HTTP_POST_VARS");

$PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];

//determine title
if ($action == "mypics"):
   $title = "My Pictures";
else:
   $title = "Search";
endif;


if ($trust_array) 
   $trust = get_array_value ($trust_array);
   
if ($audit_array) {
   $audit = get_array_value ($audit_array);
}


// make string to pass as HTTP_GET_VARS
$args = make_args ($arg_string);

if ($project_array) {
   $args .= "&serial_projarray=".urlencode (serialize ($project_array));
}
if ($keys) 
   $args .= "&" ."keywrds=".urlencode (serialize ($keys));
elseif ($keywrds) {
   $temp = stripslashes ($keywrds);
   $temp = urlencode ($temp);
   $args .= "&"."keywrds=". $temp;
}

/******************** End of initialization code ****************************/



////
// returns size of files in directory $dir
function get_dir_size ($dir) {
   clearstatcache();
   exec ("ls $dir", $ls_result); 
   if ($ls_result) {
      for ($i = 0; $i < count ($ls_result); $i++) {
         $dummy = $ls_result[$i];
         $file = $dir."/".$dummy;
         $filesize = @filesize ($file);
         $size +=  (float) $filesize;
      }
   } 
   return $size;
}


function box_raw ($selected_id,$name) {

      echo "<SELECT name='$name'>\n";
      echo "<OPTION label='raw or restored' value='ANY' ";
      echo ">raw or restored</OPTION>";
      if ($selected_id == 1)
            echo "<OPTION selected ";
         else
            echo "<OPTION ";

      echo "label=raw value=1 style='text-allign:center;'>raw</OPTION>\n";
      if ($selected_id == "0")
            echo "<OPTION selected ";
         else
            echo "<OPTION ";

      echo "label=restored value=0 style='text-allign:center;'>restored</OPTION>\n";
      echo "</SELECT>\n";                                     
} 

function box_colors ($selected_id,$name) {

   $query = "SELECT colorid,color_string,color_hex,color_text,color_sort FROM colors ORDER BY color_sort;";
   $result= db_exec ($query);
   if ($result) {
      echo "<SELECT name='$name'>\n";
      echo "<OPTION label='ANY color' value='ANY' ";
      echo " >ANY color</OPTION>\n";
      if ($selected_id == "0")
            echo "<OPTION selected ";
         else
            echo "<OPTION ";
 
      echo "label=none value=0 >none</OPTION>\n";
      for ($i=0; $i<db_NumRows($result); $i++) {
         $text = db_Result($result,$i,"color_text");
         $id = db_Result($result,$i,"colorid");
         $color = db_Result ($result, $i, "color_hex");
         if ($selected_id == $id)
            $string = "<OPTION selected ";
         else
            $string = "<OPTION ";
         $string .= "label='$text' value='$id' ";
         $string .= "style='text-align:center; background-color:$color; color:$color;'>$text</OPTION>\n";
         echo $string;
      }
      echo "</SELECT>\n";
   }
}


function box_microscopes ($selected_id) {
   $query = "SELECT microscopeid,microscope FROM microscopes;";
   $result = do_database_query ($query);                      
   $numrows = db_NumRows ($result);                           
                                                              
                                                              
   // if (!$selected_id) $selected_id = 0;                       
      echo "<SELECT size=1 name=\"microscope[]\">\n";          
   echo "<OPTION VALUE=\"ANY\">ANY</OPTION>\n"; 
                                                              
   for ($i=0; $i < $numrows; $i++) {                          
      $microscopeid = db_result($result, $i, 'microscopeid'); 
      $microscope = db_result ($result, $i, 'microscope');    
      if ($microscopeid==$selected_id)
         echo "<OPTION selected value=\"$microscopeid\">$microscope</OPTION>\n";      else                                                    
         echo "<OPTION value=\"$microscopeid\">$microscope</OPTION>\n";     
   }                                                          
                                                              
   echo "</SELECT></TD>\n";                                   
   return true;                                               
}    

function box_filetype ($type,$name) {
   global $IMAGE_TOOLS;
   // Displays select box for upload type. Pre-selects users previous choice

   echo "<SELECT NAME=\"$name\">\n";
   $result = db_exec("SELECT name FROM filetypes ORDER BY sortid;");
   $num = db_numrows($result);
   echo "<OPTION VALUE=\"ANY\">ANY</OPTION>\n";
   if ($IMAGE_TOOLS) {
      for ($i=0; $i<$num; $i++) {
         $row = db_fetch_array($result, $i);
         if ($row["name"]==$type)
            echo "<OPTION SELECTED 
                   VALUE=\"" . $row["name"] . "\">" . $row["name"] .
                  "</option>\n";
         else
            echo "<OPTION 
                   VALUE=\"" . $row["name"] . "\">" . $row["name"] . 
                  "</option>\n";
      }
   }
   // when there is no need for 3-D images
   else {
      for ($i=0; $i<$num; $i++) {
         $row = db_fetch_array($result, $i);
         if ($row["name"] != "3-D" && $row["name"] != "ICS") {
            if ($row["name"]==$searchtype)
               echo "<OPTION SELECTED 
                      VALUE=\"" . $row["name"] . "\">" . $row["name"] . "\n";
            else
               echo "<OPTION 
                     VALUE=\"" . $row["name"] . "\">" . $row["name"] . "\n";
         }
      }
   }
   echo "</SELECT>\n";
}


////
// Displays a table with names and big thumbnails of all search results
function show_gallery ($result, $columns, $size) {
   global $number_of_results, $max_in_gallery, $thumbnail_dir;
 
   if ($number_of_results > $max_in_gallery) {
      echo "<h3>No more than $max_in_gallery images can be displayed in a ";
      echo "gallery.  Please restrict your search and try again.</h3>";
   }
   else {
      echo "<table cellpadding=14%>\n";

      for ($i=0; $i < ($number_of_results/$columns); $i++) {
         // read in data about 1 row of images
         for ($j=0; ($j < $columns) && 
                    ( ( ($i * $columns) + $j) < $number_of_results); $j++) {
            $r = db_Fetch_Array ($result, ($i*$columns)+$j);
            if ($r) {
               $filetype[$j] = $r["filetype"];
               $imageid[$j] = $r["imageid"];
               $filename[$j] = $r["filename"];
               $thumb_nr[$j] = $r["thumb_nr"];
               $big_thumb_web[$j] = "showthumb.php?id=$imageid[$j]&thumbnr=$thumb_nr[$j]&kind=big&new_size=$size";
            }
         }
         // once data are know, the row of images can be displayed
         echo "<tr>\n";
         for ($j=0; ($j < $columns)  && ((($i*$columns)+$j)<$number_of_results); $j++) 
            if ($filename[$j])
               echo "<td align='center'><b>$filename[$j]</b><br>ID: $imageid[$j]<br><img src='$big_thumb_web[$j]'></td>\n";
         echo "<tr>\n";
      }
      echo "</table>\n";
         
   }
}


////
// Displays a table with names and big thumbnails of all selected search results
function show_gallery_selected ($columns, $size, $selarray) {
   global $max_in_gallery;
 
   if ($selarray) {
      while (list ($key, $val) = each ($selarray)) {
         if ($val)
            $targetarray[]=$key;
      }
   }
   if (!$targetarray)
      echo "<h3>No thumbnails were selected</h3>\n";
   $number = sizeof($targetarray);
   //echo "$number thumbs were selected<br>"; 
   if ($number > $max_in_gallery) {
      echo "<h3>No more than $max_in_gallery images can be displayed in a ";
      echo "gallery.  Please restrict your search and try again.</h3>";
   }
   else {
      echo "<table cellpadding=14%>\n";
      for ($i=0; $i < $number/$columns; $i++) {
         for ($j=0; ($j < $columns) &&       
                    ( ( ($i * $columns) + $j) < $number); $j++) {
            $imageid[$j] = $targetarray[$i * $columns + $j];
            $filename[$j] = get_image_info ($imageid[$j], "filename");
            $thumb_nr[$j] = get_image_info ($imageid[$j], "thumb_nr");
            $big_thumb_web[$j] = "showthumb.php?id=$imageid[$j]&thumbnr=$thumb_nr[$j]&kind=big&new_size=$size";
         }
      
         // once data are known, the row of images can be displayed
         echo "<tr>\n";
         for ($j=0; ($j < $columns) && ((($i*$columns)+$j)<$number); $j++) 
            if ($filename[$j])
                echo "<td align='center'><b>$filename[$j]</b><br>ID: $imageid[$j]<br><img src='$big_thumb_web[$j]'></td>\n";
         echo "<tr>\n";
      }
      echo "</table>\n";
   }
}

////
// deletes selected images
function delete_selected ($result, $selarray) {
   global $S_OUTDIR, $S_LOGIN, $number_of_results, $max_folder_size,$evansmode;
   if ($selarray) {
      while (list ($key, $val) = each ($selarray)) {
         if ($val)
            $targetarray[]=$key;
      }
   }
   else {
            
       for ($i=0; $i<$number_of_results; $i++) {
          $r = db_Fetch_Array($result, $i);
          $targetarray[$i] = $r["imageid"];
       }
   }

   if (!$targetarray)
      echo "<h3>No thumbnails were selected</h3>\n";
   $number = sizeof($targetarray);
   //echo "$number thumbs were selected<br>"; 

   // without javascript no questions asked, delete the selected images
   for ($i=0; $i < $number; $i++) {
      if (imgrights ($targetarray[$i]) ){
         $number_deleted += 1;
         imgdel ($targetarray[$i]);
      }
   }
   if ($number_deleted < 1)
      echo "<h3>No images were deleted.</h3>\n"; 
   elseif ($number_deleted == 1)
      echo "<h3>1 image was deleted.</h3>\n"; 
   elseif ($number_deleted > 1) 
      echo "<h3>$number images were deleted.</h3>\n"; 
}

////
// deconvolve selected images
function deconv_selected ($result, $selarray) {
   global $S_OUTDIR, $S_LOGIN, $number_of_results, $max_folder_size,$evansmode;

   if ($selarray) {
      while (list ($key, $val) = each ($selarray)) {
         if ($val)
            $targetarray[]=$key;
      }
   }
   else {
            
       for ($i=0; $i<$number_of_results; $i++) {
          $r = db_Fetch_Array($result, $i);
          $targetarray[$i] = $r["imageid"];
       }
   }

   if (!$targetarray)
      echo "<h3>No thumbnails were selected</h3>\n";
   $number = sizeof($targetarray);
   $deconlink = "deconvolve.php?id=".
        base64_encode(serialize($targetarray));
   echo "$number images were selected for deconvolution.<br>"; 
   echo "They should all share the same microscopic and restoration ";
   echo "parameters.<br><br><a href=\"".$deconlink."\">Proceed</a>";
   exit();

   #$html = new Html("Deconvolve image ".$_GET["id"]);

   #      $targetarray;
}
////
// script on selected images
function script_selected ($result, $selarray, $script) {
   global $S_OUTDIR, $S_LOGIN, $number_of_results, $max_folder_size,$evansmode;
   if ($selarray) {
      while (list ($key, $val) = each ($selarray)) {
         if ($val)
            $targetarray[]=$key;
      }
   }
   else {
            
       for ($i=0; $i<$number_of_results; $i++) {
          $r = db_Fetch_Array($result, $i);
          $targetarray[$i] = $r["imageid"];
       }
   }

   if (!$targetarray)
      echo "<h3>No thumbnails were selected</h3>\n";
   $number = sizeof($targetarray);
   $scriptlink = "script.php?id=".
        base64_encode(serialize($targetarray))."&script=".$script;
   echo "$number images were selected for $script.<br>"; 
   echo "They should all share the same microscopic ";
   echo "parameters.<br><br><a href=\"".$scriptlink."\">Proceed</a>";
   exit();

   #$html = new Html("Deconvolve image ".$_GET["id"]);

   #      $targetarray;
}


////
// saves all search results as file in user (or system) designated folder
function savesearchresult ($result, $selarray) {
   global $S_OUTDIR, $S_LOGIN, $number_of_results, $max_folder_size,$evansmode;  
   
   if ($S_OUTDIR) {
      // the call here should be to is_writable, which, however, 
      // produces inconsistent results
      if (is_readable ($S_OUTDIR)) {
         // check whether all or only selected should be done
         if ($selarray) {
            while (list ($key, $val) = each ($selarray)) {
               if ($val)
                  $targetarray[]=$key;
            }
            if (!$targetarray)
               echo "<h3>No thumbnails were selected</h3>\n";
         }
         else {

            for ($i=0; $i<$number_of_results; $i++) {
               $r = db_Fetch_Array($result, $i);
               $targetarray[$i] = $r["imageid"];
            }
         }
         $dir = substr (strrchr ($S_OUTDIR, "/"), 1);  
         // check wether there is enough space
         $free = diskfreespace ($S_OUTDIR);
         $dir_size = get_dir_size ($S_OUTDIR);
         if ($selarray) {
            for ($i=0; $i<sizeof($targetarray); $i++) 
               $needed_size += get_image_info ($targetarray[$i], "filesize");
         }
         else {
            for ($i=0; $i<$number_of_results; $i++) {
               $r = db_Fetch_Array ($result, $i);
               $needed_size += $r["filesize"];
            }
         }
         // echo "Free: $free, Dir size: $dir_size, Needed: $needed_size<br>";
         if ($needed_size > $free) {
            echo "<h3 style='color: red'>Retrieval not possible. ";
            echo "The server runs outof disk space. ";
            echo "Please contact you system administrator!</h3>\n";
            return false;
         }
         elseif ($needed_size > $max_folder_size) {
            $max_size = nice_bytes ($max_folder_size);
            echo "<h3 style='color: red'>Retrieval not possible.  ";
            echo "You selected more than $max_size. ";
            echo "Please restrict your search and try again.</h3>\n";
            return false;
         }
         elseif ($needed_size + $dir_size > $max_folder_size) {
            echo "<h3 style='color: red'>Retrieval not possible.  ";
            echo "Please remove files from directory <i?$dir</i> ";
            echo "and/or restrict your search and try again.</h3>\n";
            return false;
         }
         for ($i=0; $i<sizeof($targetarray); $i++) {
            if ($selarray) {
               $filetype = get_image_info ($targetarray[$i], "filetype");
               $filename = get_image_info ($targetarray[$i], "filename");
               $imageid = get_image_info ($targetarray[$i], "imageid");
               $compressed = get_image_info ($targetarray[$i], "compressed");
            }
            else {
               $r = db_Fetch_Array ($result, $i);
               if ($r) {
                  $filetype = $r["filetype"];
                  $imageid = $r["imageid"];
                  $filename = $r["filename"];
                  $compressed =$r["compressed"];
               }
            }
            if ($filename) {
               $fromfile = get_image_location ($imageid, false, $filename, 
                                               0, 0);
               if ($compressed="t")
                  uncompress ($imageid);
               $tofile = $S_OUTDIR . "/$filename";
               // to avoid double filenames
               $dot = strrpos ($tofile,".");
               $basename = substr ($tofile, 0, $dot);
               if (file_exists($tofile)) {
                  $ext_length = strlen($tofile)-$dot; 
                  $extension = substr ($tofile, $dot, $ext_length);
                  $tofile = $basename . "_001" . $extension;
                  $number = "001";
                  while (file_exists ($tofile)) {
                     $dot = strrpos ($tofile,".");
                     $ext_length = strlen($tofile)-$dot; 
                     $underscore = strrpos($tofile, "_");
                     $number = (int) substr ($tofile, $underscore+1, 
                                             $dot-$underscore-1);
                     $basename = substr ($tofile, 0, $underscore);
                     $extension = substr ($tofile, $dot, $ext_length);
                     $number += 1;
                     $number = sprintf ("%03d",$number); 
                     $tofile = $basename . "_$number" .$extension;
                  }
               }
               if ($evansmode) {
                  `ln -s $fromfile $tofile`;
               }
               else {
                  exec ("cp '$fromfile' '$tofile'");
                  exec ("chmod 666 '$tofile'"); 
               }
               $string = make_html ($imageid);
               if ($string) {
                  if ($number)
                     $html_name = $basename . "_$number" .".html";
                  else 
                     $html_name = $basename . ".html";
                  $html_file = fopen ($html_name, "w");
                  if ($html_file) {
                     fwrite ($html_file, $string);
                     fclose ($html_file);
                     exec ("chmod 666 '$html_name'");
                  }
               }
               if ($filetype == "ICS") {
                  $fromfile = get_image_location ($imageid, true, $filename, 
                                                  0, 0);
                  $tofile = $S_OUTDIR . "/" . 
                            str_replace (".ics", ".ids.gz", $filename);
                  if (file_exists ($tofile))
                     $tofile = $basename . "_$number" . ".ids.gz";
                  if ($evansmode) {
                     `ln -s $fromfile $tofile`;
                  }
                  exec ("cp '$fromfile' '$tofile'");
                  exec ("chmod 666 '$tofile'");
               }
            } 
         }
         if ($selarray)
            $number = sizeof ($targetarray);
         else
            $number = $number_of_results;
         if ($number == 1)
            echo "<p><h4>One file has been placed in directory <i>$dir</i></h4>";  
         if ($number > 1)
            echo "<p><h4>$number files have been placed in directory <i>$dir</i></h4>";
      }
      else {
         echo "The directory $S_OUTDIR is not writable for the webmaster.<br>";
         echo "The files have not been saved.<br>";
      }
   }
}

////
// displays table with thumbnails and some information of search results
function printsearchresult($result, $selarray) {
   
   global $searchquery, $start, $number_of_results, $number_of_visible_results, 
          $thumbnail_www, $args, $date_format, $max_in_gallery;
    global $PHPSESSID, $showopt, $sortby, $S_LOGIN;

// This button here may not be very elegant, but it is the easier and faster 
// method to make the "Search" button the default one when pressing return.
echo"<input type=\"submit\" name=\"submit\" tabindex=\"10\" value=\"Repeat search\"><br><br>\n";

 if ($showopt == "table" || $number_of_results==1) {
   if($number_of_results<$start+$number_of_visible_results):
      echo "<b>Printing results ".($start+1)." to ".($number_of_results).
            " from a total of $number_of_results.</b>";
   else:
      echo "<b>Printing results ".($start+1)." to ".
            ($start+$number_of_visible_results).
             " from a total of $number_of_results.</b>";
   endif;


   //printing the header of the table
   echo "<table border=1 width=100%>\n";
   echo "<tr>\n\n<th>&nbsp</th><th>Thumbnail</th>\n<th>Name</th>
         <th>Size</th><th>Type</th>
         <th>Keywords</th>\n<th>Projects</th>\n<th>Owner</th>\n<th>Upload Date</th>
         <th>Actions</th>\n";

   //for-loop that prints the actual data of the table.
   for ($i=$start; $i<($start+$number_of_visible_results) ; $i++){
      //result_row
      $r = db_Fetch_Array($result,$i);
      if($r):
      //begin of row
      echo "<tr>\n";
      //first the picture
      $imageid=$r["imageid"];
      $thumb_nr=$r["thumb_nr"];
      $filename=$r["filename"];
      // only display bytes if we have them
      if ($r["filesize"])
         $filesize=nice_bytes($r["filesize"]);
      else
         $filesize=false;
      $filetype=$r["filetype"];
      // checkbox
      if ($selarray["$imageid"])
         $selected = "checked";
      else
         $selected = false;
      echo "<td><input type='checkbox' $selected name='checkarray[]' ";
      echo "value='$imageid'></td>\n";
      $thumb = "showthumb.php?id=$imageid&thumbnr=$thumb_nr&kind=small&PHPSESSID=$PHPSESSID";
      echo "<td align=center><a href='show.php?id=".$imageid."$args'><img 
             border=0 src='$thumb' alt='$filename'></a></td>\n";

      //and then the rest
      echo "<td>$filename<br>Image ID: $imageid</td>\n";
      if ($filesize)
         echo "<td>$filesize</td>\n";
      else
         echo "<td>&nbsp;</td>\n";
      echo "<td>$filetype</td>\n";
      if ($string = show_keywords_column ($r["imageid"]))
         echo "<td cellpadding=0>".$string."</td>\n";
      else
         echo "<td><br></td>\n";
      if ($projectlist=get_project($r["imageid"], "images")) {
         echo "<td>";
         for ($j=0;$j<sizeof($projectlist);$j++){
             echo "<a href='projects.php?show=true&id=$projectlist[$j]'>".get_project_info($projectlist[$j],"name")."</a><br>";
         }
         echo "</td>\n";
      }
      else
         echo "<td>&nbsp;</td>\n";

      $email = $r["email"];
      echo "<td><a href=mailto:$email>".$r["real_name"]."</a></td>\n";
      if ($date_format == "d-m-Y")
         echo "<td>".date ("d M Y",$r["date_time"])."</td>\n";
      else
         echo "<td>".date ("M d y",$r["date_time"])."</td>\n";

      //determine the del-string
      if (imgrights($r["imageid"])):
         $delstring = "<input type=\"submit\" name=\"del_" . $r["imageid"] .
          "\" value=\"delete\" Onclick=\"if(confirm('".
          "Are you sure you want to delete this image?')){".
          "return true;}return false;\">";
      else:
         $delstring = "";
      endif;
          $deconvolvestring = "<a href=\"deconvolve.php?id=".
          $imageid."\">".
          "deconvolve</a>";
          $mrwstring = "<a href=\"mrw.php?id=".$imageid."\">".
          "MRW</a>";
          $deconvolvestring = "";  // this is preliminar (jose)
          /*
          if ($S_LOGIN == "automation")

      echo "<td align=\"center\">$delstring<br>$mrwstring</td></tr>\n";
              else
                  */
      echo "<td align=\"center\">$delstring<br>$deconvolvestring</td></tr>\n";
      endif;
   }

   echo "</table>";

 
  }
  else {
          $size = $number_of_results;
          if ($size > $max_in_gallery) $size = $max_in_gallery;
          echo "<b>Result list:</b><br>";
          echo "<select multiple size=\"$size\" name='checkarray[]'>\n";
          $totalsize=0;
          for ($i=0; $i< $number_of_results; $i++) {
             //if (! (is_dir("$image_upload_directory/".$file[$i])) )
             $r = db_Fetch_Array($result,$i);
             $imageid=$r["imageid"];
             $filename=$r["filename"];
             $filesize=$r["filesize"];
             $totalsize = $totalsize + $filesize;
             $filesize=nice_bytes($filesize);
             $owner=$r["login"];
             if ($owner != $S_LOGIN) $mark = "-" ;
             else $mark = ">";
             if ($selarray["$imageid"])                              
                 $selected = "selected";                               
             else
                 $selected = false; 
             echo "<option $selected value=\"$imageid\">$mark ";
             if ($sortby != "name") echo "ID $imageid: ";
             echo "$filename ($owner, $filesize)";
             if ($sortby == "name") echo " ID $imageid";
             echo "</option>\n";
          }
          echo "</select>\n";
          $totalsize = nice_bytes($totalsize);
          echo "<br/><b>$number_of_results files, total size: $totalsize</b><br/>\n";
  }
}


////
function printbuttons () {
  global $start, $number_of_results, $number_of_visible_results, $showopt;

 if ($showopt == "table" || $number_of_results==1) { 
  echo "<table border=0 width=100%>\n";
  if($start > 0 || $number_of_results > $start + $number_of_visible_results):
    echo "<tr>\n";
    
    if($start > 0):
      echo "<td align=\"left\"><input type=\"submit\"name=\"prev\" tabindex=25 value=\"Previous\"></td>\n";
    else:
      echo "<td><br></td>\n";
    endif;
    
    echo "<td><br></td><td><br></td><td><br></td>";
    if($number_of_results > $start+$number_of_visible_results):
       echo "<td align=\"right\"><input type=\"submit\" name=\"next\" tabindex=20 value=\"Next\"></td>\n";
    else:
      echo "<td><br></td>\n";
    endif;
    
    echo "</tr>\n";
  endif;
  echo "</table>\n";
 }

}

/********************** main body *****************************/



// do not show the header when a printable gallery has been requested
if (! ($gallery && $printgallery))
   printheader();
else 
   echo "<html>\n<body bgcolor='#ffffff'>\n";

?>

<!-- Form for database searchpage  -->

<form name="form" method="post" action="<?php echo $PHP_SELF ?>">

<?php

// Get the number of thumbs to be displayd per page from input or database, default to 10
if ($number_of_visible_results == "" || $number_of_visible_results < 1) 
   $number_of_visible_results = $S_SETTINGS["nr_visible"];
if (!$number_of_visible_results)
    $number_of_visible_results = 10;
// when changed, write the user prefs back to the database
if ($S_SETTINGS["nr_visible"] <> $number_of_visible_results) {
   $S_SETTINGS["nr_visible"] = $number_of_visible_results;
   set_user_settings ($S_USERID, $S_SETTINGS);
}

// Get the number of columns in gallery from input or database, default to 3
if ($nr_columns < 1)
   $nr_columns = $S_SETTINGS["nr_columns"];
if (!$nr_columns)
   $nr_columns = 3;
// when changed, write user prefs back to the database
if ($S_SETTINGS["nr_columns"] <> $nr_columns) {
   $S_SETTINGS["nr_columns"] = $nr_columns;
   set_user_settings ($S_USERID, $S_SETTINGS);
}

// Get the desired size of images in gallery, default to 128
if ($max_size < 1)
   $max_size = $S_SETTINGS["max_size"];
if (!$max_size)
   $max_size = 128;
// when changed, write user prefs back to the database
if ($S_SETTINGS["max_size"] <> $max_size) {
   $S_SETTINGS["max_size"] = $max_size;
   set_user_settings ($S_USERID, $S_SETTINGS);
}

if ($showopt == "" )  $showopt = $S_SETTINGS["show_opt"];
if (!$showopt)
    $showopt = "table";

if ($S_SETTINGS["show_opt"] <> $showopt) {
   $S_SETTINGS["show_opt"] = $showopt;
   set_user_settings ($S_USERID, $S_SETTINGS);
}

if ($namebool == "" )  $namebool = $S_SETTINGS["name_bool"];
if (!$namebool)
    $namebool = "and";

if ($S_SETTINGS["name_bool"] <> $namebool) {
   $S_SETTINGS["name_bool"] = $namebool;
   set_user_settings ($S_USERID, $S_SETTINGS);
}

if ($sortby == "" )  $sortby = $S_SETTINGS["sort_by"];
if (!$sortby)
    $sortby = "id";

if ($S_SETTINGS["sort_by"] <> $sortby) {
   $S_SETTINGS["sort_by"] = $sortby;
   set_user_settings ($S_USERID, $S_SETTINGS);
}



if ($HTTP_POST_VARS || $HTTP_GET_VARS) {
   //first determine the posting-method
   if ($HTTP_POST_VARS):
      $posted_vars = $HTTP_POST_VARS;
   elseif ($HTTP_GET_VARS):
      $posted_vars = $HTTP_GET_VARS;
   endif;


   //determine wether or not the delete-command is given and act on it
   while((list($key, $val) = each($posted_vars))):
      if (substr($key, 0, 3) == "del"):
         $delarray = explode("_", $key);
         imgdel($delarray[1]);
         $del = true;
         // $imageid = $delarray[1];
      endif;
   endwhile;

   //determine start-value, default is 0
   $start_old = $start;
   if($next):
      $start = $start + $number_of_visible_results;
   elseif($prev):
      $start = $start - $number_of_visible_results;
   elseif ($del):
      if ($start > 0): 
	$start-=1;
	$del = false;
      endif;
   elseif ($restart):
      $start = $restart;
   else: 
      $start = 0;
   endif;

   $restart = $start;
   $args.= "&"."restart=$restart";

   if ($serial_selarray) {
      $selarray = unserialize ($serial_selarray);
   }

   //determine wether or not my-pics mode is on
   if ($action == "mypics"):
      $loginname = $S_LOGIN;
      echo "<input type=\"hidden\" name=\"action\" value=\"mypics\">\n";
      echo "<input type=\"hidden\" name=\"start\" value=\"$start\">\n";
   endif;

   // decode keywords when present, don't understand it , but it seems to work 
   if ($keywrds  && !$keys) {
      $keys = unserialize (stripslashes (stripslashes($keywrds)));
      reset ($keys);
   }

   if(!checkdate($date_month,$date_day,$date_year)):
      $date_day ="";
      $date_month ="";
      $date_year="";
   endif;

   $searchquery = buildquery();
   $search_result = do_database_query ($searchquery);

   if($search_result) {
      // check whether to save the search results
      $number_of_results = db_numrows($search_result);
      if($number_of_results!=0) {

         // to make selection boxes work.  fill idarray 
         for ($i=0; $i<$number_of_results; $i++) {
            $r = db_Fetch_Array($search_result, $i);
            $idarray[$i] = $r["imageid"];
         }
         // determine which images were selected and de-selected
         // there are three arrays: $selarray is maintained as a posted variable
         // whereas $checkids is set by the form
        if ($showopt == "table" || $number_of_results==1) {
         if (!$start_old) $start_old = 0;
         for ($i=$start_old; $i < ($start_old+$number_of_visible_results); $i++)
         {
            if ($checkarray) {
               $selarray["$idarray[$i]"]=false;
               if (in_array ($idarray[$i], $checkarray)){
                  $selarray["$idarray[$i]"]=true;
               }
            }
         }
        }
        else {

         for ($i=0; $i < $number_of_results; $i++) {
            if ($checkarray) {
               $selarray["$idarray[$i]"]=false;
               if (in_array ($idarray[$i], $checkarray)){     
                  $selarray["$idarray[$i]"]=true;             
               }                                              
            }                                                 
         }   
        }
         // deconvolve multiple file 
         if ($deconv_selected) {
            deconv_selected ($search_result,$selarray);
         }
         if ($deconv_all) {
            deconv_selected ($search_result,false);
         }



         // delete multiple file 
         if ($remove_selected) {
            delete_selected ($search_result,$selarray);
            // since some files were deleted, search again:
            $search_result = do_database_query ($searchquery);
            $number_of_results = db_numrows($search_result);
            if($number_of_results!=0) {
               // to make selection boxes work.  fill idarray 
               for ($i=0; $i<$number_of_results; $i++) {
                  $r = db_fetch_array($search_result, $i);
                  $idarray[$i] = $r["imageid"];
               }
            }
            $selarray = false;
         }

         // delete multiple file 
         if ($remove_all) {
            delete_selected ($search_result,false);
            
            // since some files were deleted, search again:
            $search_result = do_database_query ($searchquery);
            $number_of_results = db_numrows($search_result);
            if($number_of_results!=0) {
               // to make selection boxes work.  fill idarray 
                for ($i=0; $i<$number_of_results; $i++) {
                  $r = db_fetch_array($search_result, $i);
                  $idarray[$i] = $r["imageid"];
               }
            }
            $selarray = false;
         }

         // serialize the array to pass it along with the form
         $serial_selarray = serialize ($selarray);
         echo "<input type='hidden' name='serial_selarray' value='$serial_selarray'>\n";
            
         if ($save) 
            savesearchresult($search_result, false);
         if ($save_sel) {
            if ($selarray)
               savesearchresult($search_result, $selarray);
            else
                echo "<h3>No images selected.  None saved</h3>";
         }
         if ($gallery) {
            if ($allsel=="all") 
               show_gallery ($search_result, $nr_columns, $max_size);
            if ($allsel=="sel")
               show_gallery_selected ($nr_columns, $max_size, $selarray);
         }
         else {
            
            printbuttons ();
            printsearchresult($search_result, $selarray);
            printbuttons (); 
         }
      }
      else 
         echo "<b>No results available!</b><br>";
   }
   else
      echo "<b>Query failed!</b><br>";
}


// do not show anything else when a printable gallery has been request
if (! ($gallery && $printgallery)) {

   if ($number_of_results > 0) {
      echo "<hr>\n";

      // gallery button
      echo "<table border=0>\n";
      echo "<tr><td><input style='align:left' type='submit' name='gallery' tabindex='4' value='Show Gallery'></td>\n";
      echo "  <td>Columns in gallery: ";
      echo "<input type='text' name='nr_columns' value='$nr_columns' size=4 maxlength=2></td>\n";
      echo "  <td>Max size in pixels: ";
      echo "<input type='text' name='max_size' value='$max_size' size=4 maxlength=3></td>\n";
      echo "  <td>Printable: ";
      if ($printgallery)
         $checked = "checked";
      echo "<input type='checkbox' $checked  name='printgallery' value='on'></td></tr>\n";
      if (!$allsel)
         $allsel = "sel";
      if ($allsel=="all") {
         $checkall = "checked";
         $checksel = false;
      }
      elseif ($allsel=="sel") {
         $checkall = false;
         $checksel = "checked";
      }
      echo "<tr><td></td><td><input type='radio' name='allsel' value='all' $checkall>All</td>\n";
      echo "<tr><td></td><td><input type='radio' name='allsel' value='sel' $checksel>Selected</td></tr>\n";
      echo "</table>\n";
      echo "<hr>\n";

      // button to delete selected images
      if (!$gallery || ($gallery && $allsel='sel')) {
         echo "<input style='align:right' color='red' type='submit' name='remove_selected' tabindex=4 value='Delete selected' ";
         echo "onClick=\"if(confirm('Your are about to delete one or more images.\\nAre you sure that you want to proceed?')){return true;} return false;\">\n";
         echo "$nbsp&nbsp";
         echo "<input style='align:right' color='red' type='submit' name='remove_all' tabindex=5 value='Delete all $number_of_results images' ";
         echo "onClick=\"if(confirm('Your are about to delete one or more images.\\nAre you sure that you want to proceed?')){return true;} return false;\">\n";         echo "$nbsp&nbsp";   
      }
   
      // offer 'save images' button when $outfolder has been set
      if ( $S_OUTDIR) {
         echo "<input style='align:left' type='submit' name='save' tabindex='6' value='Save all $number_of_results images'>\n";
         if (!$gallery || ($gallery && $allsel='sel')) {
            echo "&nbsp&nbsp";
            echo "<input type='submit' name='save_sel' tabindex='7' value='Save selected'>\n";
         }  
      }

     // button to deconvolve selected images
     /*
      if (!$gallery || ($gallery && $allsel='sel')) {
         echo "<input style='align:right' color='red' type='submit' name='deconv_selected' tabindex=4 value='Deconvolve selected' >\n";
         echo "<input style='align:right' color='red' type='submit' name='deconv_all' tabindex=5 value='Deconvolve all $number_of_results images'>\n ";
      }
      */


      echo "<hr>";
   }

   if(!(isset($date_day)&&isset($date_month)&&isset($date_year))):
      //fill in the current time
      $date_day = date("d", time());
      $date_month=date("m", time());
      $date_year = date("Y", time());
   endif;


   if ($action != "mypics"):
?>

<p><b>Please enter the fields you want to search on (multiple inputs possible)</b></p>

<?php
         if ($showopt=="list" || $showopt==false || $showopt=="") 
                $checked = "checked";
         else $checked = "";
         echo "<INPUT type='radio' $checked name='showopt' value='list'> Show simple list <BR>\n";
         if ($showopt=="table") $checked = "checked";         
         else $checked = "";  
         echo "<INPUT type='radio' $checked name='showopt' value='table'> 
          Show thumbnails table with <input type=\"text\"  
           value=\"$number_of_visible_results\" 
           name=\"number_of_visible_results\" 
          size =3> results.  <BR>";


?>                                                            
<table>


<tr>
   <td>Image Name:</td>
   <td><input type="text" value="<?php echo $file_name ?>" name="file_name">
       <font size=-1> use * ? [1-3] (a|b)</font>
<?php
   if ($namebool=="or") $checked = "checked";
   else $checked = "";
   echo "<INPUT type='radio' $checked name='namebool' value='or'> Any (OR)\n";
   if ($checked == "") $checked = "checked"; else $checked = "";
   echo "<INPUT type='radio' $checked name='namebool' value='and'> All (AND)\n";
?>
</td>
</tr>
<tr>
   <td>Image ID:</td>
   <td><input type="text" value="<?php echo $file_id ?>" name="file_id"> 
      <font size=-1>n, &gt; &lt;= != n, n-m, reg.exp * ? [1-3] (a|b)</font>
</td>
</tr> 

<tr>  
<?php
      $query2 = imgright_query ($S_USERID, "userid", "");
      box_users ($trust, "Image Owner: ", "WHERE userid IN ($query2)", "trust_array[]"); 
      echo "</tr>\n<tr>";
      $query2 = imgright_query ($S_USERID, "trust", "");
      box_users ($audit, "User specifically allowed <br>to see the image: ", "WHERE userid IN ($query2)", "audit_array[]"); 
?>
</tr>
<tr>      
<td>Description of the image :</td>
<td><input type="text" size=50 value="<?php echo $des_cription ?>" name="des_cription"></td>
</tr>
<tr>
<td>Date of upload:</td>
<td colspan=2>
<select name="period_nr">
<option value="" <?php if ($period_nr=="") echo "selected"; ?> >&nbsp</option>
<?php
   for ($i=1; $i<13; $i++) {
      if ($i == $period_nr)
         echo "<option value=$i selected>$i</option>\n";
      else 
         echo "<option value=$i>$i</option>\n";
   }
?>
</select>
<select name="period">
<option value="" <?php if ($period=="") echo "selected"; ?> >&nbsp</option>
<option value="day" <?php if ($period=="day") echo "selected"; ?> >day(s)</option> 
<option value="week" <?php if ($period=="week") echo "selected"; ?> >week(s)</option>
<option value="month" <?php if ($period=="month") echo "selected"; ?> >month(s)</option>
<option value="year" <?php if ($period=="year") echo "selected"; ?> >year(s)</option>
</select>
<select name="date_comparison">
<option value="on"<?php if ($date_comparison=="on"):echo "selected";  endif;?> >on/around</option>
<option value="after" <?php if ($date_comparison=="after"):echo "selected";  endif;?> >after</option>
<option value="before"
<?php
      //to make sure before is selected before any queries are made and if it was selected on submit that it will stay selected
      if($date_comparison=="before"||($date_comparison!="after" && $date_comparison!="on")):
         echo "selected";
      endif;
   ?>
>before</option>
</select>

<?php 
      if ($date_format == "d-m-Y") {
         echo "<input type='text' size=2 maxlength=2 value=\"$date_day\""; 
         echo " name=\"date_day\">-";
         echo "<input type='text' size=2 maxlength=2 value=\"$date_month\""; 
         echo "name='date_month'>-";
      }
      elseif ($date_format == "m-d-Y") {
         echo "<input type='text' size=2 maxlength=2 value=\"$date_month\""; 
         echo "name='date_month'>-";
         echo "<input type='text' size=2 maxlength=2 value=\"$date_day\""; 
         echo " name=\"date_day\">-";
      }
      echo "<input type='text' size=4 maxlength=4 value=\"$date_year\""; 
      echo "name='date_year'>";
      if ($date_format == "d-m-Y")
         echo "&nbsp(DD-MM-YYYY)</td></tr>";
      elseif ($date_format == "m-d-Y")
         echo "&nbsp(MM-DD-YYYY)</td></tr>";


      $the_keys[]=new key_word_id;
      $the_keys= get_keyword_list();
      $nr_keywords= count($the_keys);
      $maxsize=5;

      if ($nr_keywords > 0 && $the_keys[0]->keywordid<>0 ) {
         echo "<TR><TD valign='top'>Keywords<br>\n";
         if ($keybool=="or" || $keybool==false) $checked = "checked";
         else $checked = "";
         echo "<INPUT type='radio' $checked name='keybool' value='or'> Any keyword (OR)<BR>\n";
         if ($keybool=="and") $checked = "checked";
         else $checked = "";
         echo "<INPUT type='radio' $checked name='keybool' value='and'> All keywords (AND)<BR>\n";
         if ($nr_keywords < $maxsize) 
         $size = $nr_keywords;
         else
            $size = $maxsize;
         echo "</TD><TD><SELECT multiple size=\"$size\" name=\"keys[]\">\n";
         for ($i=0; $i<count($the_keys); $i++) {
            //$temp = new key_word_id;
            $temp=$the_keys[$i];
            $temp->keyword = trim ($temp->keyword);
            if ($keys) {
               if (in_array ($temp->keywordid, $keys) )
                  echo "<OPTION selected value=\"$temp->keywordid\">$temp->keyword</OPTION>\n";
               else
                  echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n"; 
            }
            else {
                  echo "<OPTION value=\"$temp->keywordid\">$temp->keyword</OPTION>\n"; 
            }
         }
         echo "</SELECT></td>\n";
         // we are getting the selected projects both as an array and a single
         box_projects ($project_array, "Project", false, "project_array[]", 
                       "multiple");
      }
?>

</tr>
<tr>
  <td>File type: 
      </td><td><?php box_filetype($searchtype,searchtype);
                  box_raw($file_raw,file_raw);  ?></td></tr>
<tr>
   <td>Thumbnail xyt (pixels, fps):</td>
   <td><input type="text" value="<?php echo $file_thumbx ?>" name="file_thumbx"
       tabindex="1" size="5">
     <input type="text" value="<?php echo $file_thumby ?>" name="file_thumby" 
       tabindex="1" size="5">
     <input type="text" value="<?php echo $file_thumbt ?>" name="file_thumbt" 
       tabindex="1" size="5"> 
         <font size=-1>n, &gt; &lt;= != n, n-m, reg.exp * ? [1-3] (a|b)</font>
 </td>
</tr>


<tr>
   <td>Image size xyz (pixels):</td>                      
   <td><input type="text" value="<?php echo $file_x ?>" name="file_x"
       tabindex="1" size="5">                                 
     <input type="text" value="<?php echo $file_y ?>" name="file_y"
       tabindex="1" size="5">                                 
     <input type="text" value="<?php echo $file_z ?>" name="file_z" 
       tabindex="1" size="5">                                 
 </td>                                                        
</tr>    

<tr>
   <td>Sampling xyzt (nm, s):</td>
   <td>
     <input type="text" value="<?php echo $file_samplex ?>" name="file_samplex"
        size="5">
     <input type="text" value="<?php echo $file_sampley ?>" name="file_sampley" 
       size="5">
     <input type="text" value="<?php echo $file_samplez ?>" name="file_samplez" 
       size="5">
   <input type="text" value="<?php echo $file_samplet ?>" name="file_samplet"
       size="5">

  </td>
</tr>    
<tr><td>Microscope type</td>
    <td><?php $microscope_type = get_array_value ($microscope); 
          box_microscopes($microscope_type); ?></td>

</tr>
<tr>
   <td></td><td>Lens NA:
   <input type="text" value="<?php echo $file_NA ?>" name="file_NA"  size="3">
   r.i.:  <input type="text" value="<?php echo $file_lri ?>" name="file_lri" 
           size="5">
  medium r.i.: <input type="text" value="<?php echo $file_mri ?>" 
                 name="file_mri" size="5">
  </td>
</tr>
<tr><td>Number of channels:</td>
 <td><input type="text" value="<?php echo $file_numchan ?>" name="file_numchan"
       size="2"></td>
</tr>

<tr><td>In channel
 <input type="text" value="<?php echo $file_inchan ?>" name="file_inchan"
       size="2"> it has:</td>
<td> Excit <input type="text" value="<?php echo $file_ex ?>" 
                 name="file_ex" size="4">
     Emis <input type="text" value="<?php echo $file_em ?>" 
                 name="file_em" size="4">
     Photon <input type="text" value="<?php echo $file_photon ?>"  
                 name="file_photon" size="2">
     Pinhole <input type="text" value="<?php echo $file_ph ?>"  
                 name="file_ph" size="4">
     <?php box_colors ($file_color, file_color);?>



</tr>

<tr>
   <td>Sort by image:</td>
   <td>
<?php
   if ($sortby=="id") $checked = "checked";
   else $checked = "";
   echo "<INPUT type='radio' $checked name='sortby' value='id'> ID\n";

   if ($sortby=="name") $checked = "checked";
   else $checked = "";
   echo "<INPUT type='radio' $checked name='sortby' value='name'> Name\n";

   if ($sortby=="date") $checked = "checked";
   else $checked = "";
   echo "<INPUT type='radio' $checked name='sortby' value='date'> Date\n";
?>
</td>
</tr>



<tr>
   <td><br><b><input type="submit" name="submit" tabindex="10" value="Search Database"></b></td>
   <td><br><b><input type="reset" name="reset" tabindex="10" value="Reset"></b></td>
</tr>
</table>
<input type="hidden" name="start" value="<?php echo $start; ?>">

<?php else: //when mypics
?>


<?php
         if ($showopt=="list" || $showopt==false || $showopt=="") 
                $checked = "checked";
         else $checked = "";
         echo "<INPUT type='radio' $checked name='showopt' value='list'> Show simple list <BR>\n";
         if ($showopt=="table") $checked = "checked";         
         else $checked = "";                                  
         echo "<INPUT type='radio' $checked name='showopt' value='table'> 
          Show thumbnails table with <input type=\"text\"  
           value=\"$number_of_visible_results\" 
           name=\"number_of_visible_results\" 
          size =3> results.  <BR>";                                   
                                                              
                                                              
/*                                                             
<tr>                                                          
    <td> Results per table :</td>                   
    <td> <input type="text"  tabindex="1" value="<?php echo $number_of_visible_results ?>" name="number_of_visible_results" size =2></td></tr>
                                                              
</tr>
*/
?>                                                            
<table>
<tr>
   <td><br><b><input type="submit" name="submit" tabindex="2" value="Show My Pictures"></b></td>
</tr>
</table>

<?php endif; ?>

</form>


<?php
   printfooter();
} // end of if (! ($gallery && $printgallery))
else
   echo "\n</body>\n</html>";
?>
