<?php

// showtumb.php - Sends a thumbnail image
// showthumb.php - author: Nico Stuurman <nicost@sidb.sf.net> 
  /***************************************************************************  
  * This script sends a thumbnail image.                                     *
  * It should be called from within an <img> tag.                            *
  * Expected parameters are:   id (imageid), kind (small, big, movie),       *
  *    thumbnr (thumb_nr).                                                   *
  * Use this script instead of sending the thumbnail directly, because the   *
  *   script checks whether the user has the rights to see the thumbnail.    *
  *                                                                          *
  * Created by Nico on 6-1-2001.                                             *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: nicost@sidb.sf.net                                                *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000,2001 by Nico Stuurman                                 *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/ 

// include functions and authorize user
require ("include.php");

// first check the input parameters
$id = $HTTP_GET_VARS["id"];
$thumbnr = $HTTP_GET_VARS["thumbnr"];
$new_size = $HTTP_GET_VARS["new_size"];
$kind = $HTTP_GET_VARS["kind"];
$view = $HTTP_GET_VARS["view"];
if ($view != "") $view = "_".$view;

$id = (int)$id;
$thumbnr = (int)$thumbnr;

// check whether user may see this image

if ($id > 0)
{
    // avoids errors when no or a weird id has been given
    //if (imgviewrights($id, $S_USERID))
    //{
        // images: (note that only $kind == small, big, or movie is accepted
        if ($kind == "small" || $kind == "big")
	{
            $thumblocation = "$thumbnail_dir/$kind/$id"."_"."$thumbnr$view.jpg";
	    #print("THUMBLOCATION: $thumblocation");
            // when requested to re-size the thumbnail on the fly:
            if ($new_size)
	    {
		// when the file-type is 2-D and not too big 
		// use the original, otherwise the big thumbnail
		if ((get_image_info ($id, "filetype") == "2-D")
		    && (get_image_info ($id, "filesize") < $max_size_for_convert))
		{
		    $thumblocation = "\"".get_image_location ($id)."\"";
		}
		if (get_image_info($id, "compressed") == "t")
		{
		    uncompress($id); 
		}
		$tempfile = "$archive_dir/tmp/$id".".jpg";
		//echo "thumb: $thumblocation, temp: $tempfile<br>";
		$image_settings = get_image_settings ($id);
		if ($rotation = $image_settings["rotation"]) 
		{
		    $rotation_string = "-rotation $rotation";
		}
		system("$convert_path -sample ".$new_size."x".$new_size." ".
		       $thumblocation." ".$rotation_string." jpg:".$tempfile);
		$thumblocation = $tempfile;
	    }
	    if (is_readable($thumblocation))
	    {
	       // let browser know to expect an image
	       Header("Content-Type: image/jpeg");
	       readfile ($thumblocation);
	       if ($new_size)
	       {
	           unlink($tempfile);
	       }
	    } 
        else {
           $type = get_image_info ($id, "filetype");
           // use default thumbnail
           if ($type == "2-D" or $type == "multipage") {
            Header("Content-Type: image/png");
            readfile ("images/doc_image.png");
           }
           else if ($type == "3-D" or $type == "ICS") {
            Header("Content-Type: image/png");
            readfile ("images/doc_3dimage.png");
           }
           else {
            Header("Content-Type: image/png");
            readfile ("images/doc_other.png");
           }

        }
	}
	elseif ($kind == "movie")
	{
	    $thumblocation = "$thumbnail_dir/$kind/$id"."_"."$thumbnr.mpg";
	    if (is_readable($thumblocation))
	    {
		Header("Content-Type: video/mpeg");
		readfile ($thumblocation);
	    }
	}
    //}
}

?>
