<?php

  /**************************************************************************\
  * sizebar.php   outputs an image of a sizebar                              *
  ***************************************************************************
  * The script needs the pixel/voxel size in nm and the ratio between pixel  *
  * sizes of the original and thumbnail and will output an png image of a    *
  * bar.  Maybe this is even usefull in other applications?                  *
  *                                                                          *
  * Authors: Nico Stuurman                                                   *
  * email: nicos@itsa.ucsf.edu                                               *
  * demo at: http://impi.leidenuniv.nl                                       *
  * Copyright (c) 2001 by Nico Stuurman                                      *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/         
// converts a size (in nm) in well-formatted string
function size2text ($size) {
   // the resultof the division could be a double
   if ($size/1000 < 1)
      return floor($size) . " nm";
   if ($size/1000000 < 1)
      return floor($size/1000) . " um";
   if ($size/1000000000 < 1)
      return floor($size/1000000) . " mm";
   if ($size/1000000000000 < 1)
      return floor($size/1000000000) . " m";
   if ($size/1000000000000 < 1)
      return floor($size/1000000000) . " m";
   return floor($size/1000000000000) . " km";
}

// tries to make a nice sizebar
$xsize=$HTTP_GET_VARS['xsize'];
// ratio between thumbnail size and original size
$ratio=$HTTP_GET_VARS['ratio'];

// protect against nonsense and crashes
if (!$xsize || !$ratio)
   exit();
if (! function_exists(ImagePng))
   exit();

// estimate a nice length for the size bar
$size=1;
$sizebar=$size/$xsize*$ratio;
while ($sizebar<50) {
   $size_string = (string) $size;
   if ($size_string[0]==2)
      $size*=2.5;
   else
      $size*=2;
   $sizebar=$size/$xsize*$ratio;
}
// create and return the sizebar image
$imagexsize=$sizebar+20;
$im = ImageCreate ($imagexsize,30);
$white = ImageColorAllocate($im,255,255,255);
$black = ImageColorAllocate($im,0,0,0);
ImageFill ($im,0,0,$white);
// center the sizebar
$xstart = ($imagexsize-$sizebar)/2;
ImageFilledRectangle($im,$xstart,20,$xstart+$sizebar,25,$black);
//center the sizebar string
$font=2;
$text=size2text($size);
$offsetx = 0.5 * ($imagexsize-(Imagefontwidth($font) * strlen($text) ));
ImageString ($im,$font,$offsetx,5,$text,$black);
//first the anti-caching headers
header("Cache-control: private, no-cache, must-revalidate");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Pragma: no-cache");
Header ("Content-Type: image/png");
ImagePng ($im);  
ImageDestroy ($im);
?>
