<?php

require ("include.php");

Auth::allowonly ($G_SUPER);
$title = "Upgrade from version 0.11";

printheader ();

$query = "ALTER TABLE images ADD COLUMN settings text";

do_database_query ($query);

$query = "ALTER TABLE images ADD COLUMN x_pixel smallint";
do_database_query ($query);

$query = "ALTER TABLE images ADD COLUMN y_pixel smallint";
do_database_query ($query);

$query = "ALTER TABLE images ADD COLUMN z_pixel smallint";
do_database_query ($query);

echo "<h3>fields: settings, x_pixel, y_pixel, z_pixel have been added to the database<br>";

echo "Now remaking all 2-D images.  Regretfully, this will reset the rotation, and users will have to rotate images again themselves.  On the upside, from now on that database will remember the rotation and the size in pixels of each 2-D image.</h3><br>";

$query = "SELECT filetype, imageid, filename FROM images WHERE filetype='2-D';";
$db_result = do_database_query ($query);
$db_rows = pg_numrows ($db_result);
for ($i=0; $i < $db_rows; $i++){
   $db_row_result = pg_fetch_array($db_result, $i);
   $filetype = $db_row_result["filetype"];
   $filesize = $db_row_result["filesize"];
   if ( ($filetype == "2-D") && ($filesize < 2097152) ) {
      $filename = $db_row_result["filename"];
      $imageid = $db_row_result["imageid"];
      echo "now processing id: $imageid, name: $filename<br>";
      other_thumbnail ($filename, $imageid);
   }
}
 

// when we made it here, it must have worked!
echo "Upgrade succeeded<br>";


printfooter ();

?>
