<?php

  // upload.php - Handles file uploads through HTML and mounted drives      
  /***************************************************************************
  * This script displays the 'pre-upload' form, the upload form, and handles *
  * the upload as well as display (through show_inc.php) of the uploaded file*
  *                                                                          *
  * ------------------------------------------------------------------------ *
  *                     FUNCTIONS                                            *
  * show_initial_page()                                                      *
  * show_first_page()                                                        *
  * printuploadform()                                                        *
  * upload_file()                                                            *
  * make_js_array ($where_string)                                            *
  *                                                                          *
  * ------------------------------------------------------------------------ *
  *                                                                          *
  * Authors: SVI group University Utrecht and Nico Stuurman                  *
  * email: stuurman@rulbim.leidenuniv.nl                                     *
  * demo at: https://impi.leidenuniv.nl                                      *
  * Copyright (c) 2000, 2001 by Nico Stuurman                                *
  * ------------------------------------------------------------------------ *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/                                                                     


$title = "Enter images into the database";
require("include.php");
require ($include_dir."/template_inc.php");
require ($include_dir."/image_inc.php");

$PHP_SELF = $HTTP_SERVER_VARS["PHP_SELF"];

// get posted variables:
$posted_vars = "add,filetype,templateid,uploadtype,next,nextp,";
$posted_vars .= "time_stamp,file,import_comments,resubmit,description,";
$posted_vars .= "exp_date_text,exp_date_box,raw_data,";
$posted_vars .= "keys,viewrights,trust_array,x_thumb,y_thumb,upload,";
$posted_vars .= "x_nm,y_nm,z_nm,t_sec,";
$posted_vars .= "scope,refrinxlensmedium,numaperture,refrinxmedium,";
$posted_vars .= "channels,nr_channels,channel_up,upload,fs,projects,";
$posted_vars .= "upload_as_user,image_upload_directory,extra_metadata_file";

globalize_vars ($posted_vars, "HTTP_POST_VARS");

// get file variable php4 style.  
$location = $HTTP_POST_FILES["location"]["tmp_name"];
$location_name = $HTTP_POST_FILES["location"]["name"];
$location_type = $HTTP_POST_FILES["location"]["type"];
$locationids = $HTTP_POST_FILES["locationids"]["tmp_name"];
$locationids_name = $HTTP_POST_FILES["locationids"]["name"];
$location_thumb = $HTTP_POST_FILES["location_thumb"]["tmp_name"];
$metadata_file = $HTTP_POST_FILES["metadata_file"]["tmp_name"];
$metadata_file_name = $HTTP_POST_FILES["metadata_file"]["name"];


////
// !Shows 'pre-upload' page
// Choose, file, template and html/local upload method here
function show_initial_page() 
{
   global $S_USERID, $S_HOMEDIR, $S_SETTINGS, $IMAGE_TOOLS, $TD_only;

   if ($TD_only)
      echo "<h2>Select a template</h2>\n";
   else
      echo "<h2>Select filetype and template</h2>\n";
   ?>
   <FORM enctype="multipart/form-data" METHOD="post" 
    ACTION="upload.php" >

   <TABLE BORDER="0">

   <?php
   if (!$TD_only) {
      echo "<tr><td>Select a filetype:</td>\n<td>\n\n";
  
      $jscript = "onChange=\"fillSelectFromArray(this.form.templateid,
               ((this.selectedIndex == -1) ? null : modelinfo[this.selectedIndex]));\"";
      box_type($jscript);
      echo "</td></tr>\n";
   }
   else
      echo "<input type='hidden' name='filetype' value='2-D'>\n";

   echo "<tr><td>Select a template:</TD><TD><SELECT NAME=\"templateid\">\n";

   $result = db_exec("SELECT templatename, templateid, filetype FROM template WHERE userid = '$S_USERID';"); 
   $num = db_numrows($result);

   if ($S_SETTINGS["templateid"]==0)
      echo "<OPTION SELECTED VALUE=\"0\" >No Template";
   else
      echo "<OPTION VALUE=\"0\" >No Template";
   for ($i=0; $i<$num; $i++){
      $row = db_fetch_array($result, $i);
      if ($S_SETTINGS["templateid"]==$row["templateid"]) {
         echo "<OPTION SELECTED 
           VALUE=\"" . $row["templateid"] . "\">" . $row["templatename"] . "\n";
      }
      else {
         echo "<OPTION 
           VALUE=\"" . $row["templateid"] . "\">" . $row["templatename"] . "\n";
      }
   }

   echo "</SELECT></TD></TR>\n";
   echo "</TD></TR>\n";
   echo "<BR><TR><TD><BR>\n";
   $darr=get_upload_dir();
   
   if (count($darr)>0) {
      if ($S_SETTINGS["uploadtype"]=="html") {
         echo "<LABEL ACCESSKEY=H><INPUT type='radio' checked 
               name='uploadtype' value='html'> HTML file upload</LABEL><BR>\n";
         echo "<LABEL ACCESSKEY=M><INPUT type='radio' name='uploadtype' 
              value='move'> Move file from an image directory</LABEL><BR>\n"; 
      }
      else {
         echo "<LABEL ACCESSKEY=H><INPUT type='radio'  name='uploadtype' 
               value='html'> HTML file upload</LABEL><BR>\n";
         echo "<LABEL ACCESSKEY=M><INPUT type='radio' checked name='uploadtype'
               value='move'> Move file from an image directory</LABEL><BR>\n";
      }
      echo "Image Directory: <select name='image_upload_directory'>\n";
      
      for (reset($darr);list($key,$val)=each($darr);){
          if ($S_SETTINGS["image_upload_directory"]==$key)
             $selected="selected";
          else
             $selected=false;
	  echo "<option $selected value='$key'>$val\n";
      }
      echo "</SELECT><BR>\n";
   }
   else {
      echo "<INPUT type='hidden' name='uploadtype' value='html'>\n";
   }
   echo "</TD> <TD ALIGN='right'><INPUT TYPE='submit' NAME='next' 
         VALUE='Next'>\n";
   echo "</TD></TR></TABLE></FORM>\n";
}


////
// !Shows first line of upload page
// Allows to change, file, template and html/local upload method here
function show_first_page() {
   global $S_USERID, $S_HOMEDIR, $S_SETTINGS, $IMAGE_TOOLS, $TD_only;

   $js="onChange='document.firstform.nextp.value=\"Change\"; document.firstform.submit()'";
   echo "<form enctype=\"multipart/form-data\" method=\"post\" action=\"upload.php\" name=\"firstform\">\n";
   echo "<input type='hidden' name='nextp' value=''>\n";
   echo "<table border='0'>\n";

   // row with headers
   echo "<tr>\n";
   if (!$TD_only) {
      echo "<td>filetype</td>\n";
   }
   else
      echo "<input type='hidden' name='filetype' value='2-D'>\n";
   echo "<td>template</td>\n";

   // file upload stuff
   echo "<td rowspan='2'>\n";
   $darr=get_upload_dir();
   
   if (count($darr)>0) {
      if ($S_SETTINGS["uploadtype"]=="html") {
         echo "<LABEL ACCESSKEY=H><INPUT type='radio' checked 
               name='uploadtype' value='html' $js> HTML file upload</LABEL><BR>\n";
         echo "<LABEL ACCESSKEY=M><INPUT type='radio' name='uploadtype' 
              value='move' $js> Move file from an image directory</LABEL><BR>\n"; 
      }
      else {
         echo "<LABEL ACCESSKEY=H><INPUT type='radio'  name='uploadtype' 
               value='html' $js> HTML file upload</LABEL><BR>\n";
         echo "<LABEL ACCESSKEY=M><INPUT type='radio' checked name='uploadtype'
               value='move' $js> Move file from an image directory</LABEL><BR>\n";
      }
      echo "Image Directory: <select name='image_upload_directory' $js>\n";
      
      for (reset($darr);list($key,$val)=each($darr);){
          if ($S_SETTINGS["image_upload_directory"]==$key)
             $selected="selected";
          else
             $selected=false;
	  echo "<option $selected value='$key'>$val\n";
      }
      echo "</select>\n";
   }
   else {
      echo "<input type='hidden' name='uploadtype' value='html'>\n";
   }
   echo "</td>\n<td align='right' rowspan='2'><input type='submit' name='next' value='Change'></td</tr>\n";

   // row with content
   echo "<tr>";
   if (!$TD_only) {
      echo "<td>\n";
   $js="onChange='document.firstform.nextp.value=\"Change\"; document.firstform.submit()'";
      $jscript = "onChange='fillSelectFromArray(this.form.templateid,
               ((this.selectedIndex == -1) ? null : modelinfo[this.selectedIndex])); document.firstform.nextp.value=\"Change\"; document.firstform.submit()'";
      box_type($jscript);
      echo "</td>\n";
   }

   echo "<td><select name=\"templateid\" $js>\n";
   $result = db_exec("select templatename, templateid, filetype from template where userid = '$S_USERID';"); 
   $num = db_numrows($result);

   if ($S_SETTINGS["templateid"]==0)
      echo "<OPTION SELECTED VALUE=\"0\" >No Template";
   else
      echo "<OPTION VALUE=\"0\" >No Template";
   for ($i=0; $i<$num; $i++){
      $row = db_fetch_array($result, $i);
      if ($S_SETTINGS["templateid"]==$row["templateid"]) {
         echo "<OPTION SELECTED 
           VALUE=\"" . $row["templateid"] . "\">" . $row["templatename"] . "\n";
      }
      else {
         echo "<OPTION 
           VALUE=\"" . $row["templateid"] . "\">" . $row["templatename"] . "\n";
      }
   }
   echo "</select></td>\n";
   echo "</tr>";

   if ($S_SETTINGS["filetype"]=="ICS") {
       echo "<tr><td colspan ='4'> <b>Important:</b> ICS type is for ICS1 ";
       echo "format. For <b>ICS2 format</b>, please select type 3-D. ";
       echo "<a href='http://support.svi.nl/wiki/ICSfileFormat' target='ICS'>";
       echo "Read more</a>.";
       echo "</td></tr>";
   }
 
   
   echo "</table></form>\n";
   echo "<hr>\n";
}


/*
 * This function prints a part of the table for the upload page.
 * That part is the tabel row 'upload as'.
 */
function printUploadAsUser()
{
    global $S_STATUS, $G_SUPER, $S_GROUPID, $S_USERID;
    // Admins are allowed to upload as another user.
    print("<tr>");
    print("<td>Upload as user</td>");
    print("<td>");
    print("<select name='upload_as_user'>\n");
    // Super admin can select all users.
    if ($S_STATUS == $G_SUPER)
    {
	$uarr=get_all_users();
    }
    // Group admins are allowed to upload as their users.
    else
    {
	$uarr=get_all_group_users($S_GROUPID);
    }
    // Then for each user print it as an option.
    for (reset($uarr);list($id,$user)=each($uarr);)
    {
	// If user is itself, print it as selected.
	$sel = ($S_USERID == $id) ? " selected" : "";
	echo "<option value='$id'$sel>$user\n";
    }
    print("</select>");
    print("</td>");
    print("</tr>\n");
}
/*
 * End neat code by Frank Keijzers (SVI).
 */


////
// !Creates a table with image metadata.
// When available pull initial data from template.
// Present different fields for 2-D and 3-D data.
function printuploadform() {
   global $add, $templateid, $S_USERID, $S_HOMEDIR, $S_SETTINGS;
   global $location, $filetype, $uploadtype, $image_fields,$image_upload_directory;
   global $G_SUPER, $G_ADMIN,$S_STATUS, $S_GROUPID;

   //calculate maximum upload file size.  This is also limited by post_max_size!
   $post_size = ini_get ("post_max_size");
   if (strstr ($post_size, "M"))
      $post_size *= 1048576;
   $upload_size = ini_get ("upload_max_filesize");
   if (strstr ($upload_size, "M"))
      $upload_size *= 1048576;
   if ($post_size && $upload_size)
      $max_size = min ($post_size, $upload_size);
   else
      $max_size = $upload_size;
   $max_file_size_mb = nice_bytes ($max_size);
  
   show_first_page();

   echo "<FORM name=\"uploadform\" ENCTYPE=\"multipart/form-data\" 
          METHOD=\"post\" ACTION=\"upload.php\">\n";

   // add time/date stamp to enable later checking whether the submission had 
   // taken place previously
   $time_stamp = time();
   echo "<INPUT TYPE ='hidden' NAME='time_stamp' VALUE='$time_stamp'>\n";
   
   
   if ($uploadtype=="html") {
      echo "<H3>Enter the image metadata and select a file. ";
      echo "The maximum filesize is $max_file_size_mb.</H3>\n";
      echo "<INPUT TYPE ='hidden' NAME='uploadtype' VALUE='html'>\n";     
      echo "<TABLE BORDER=\"0\">\n";
      show_image_form ($filetype, "new", $image_fields, $templateid);
      echo "<tr><td>File location</td>";
      echo "<td><input type=\"file\" name=\"location\" value=\"$location\">";
      echo "</td></tr>\n";
   
      // If filetype is ICS then the IDS file must also be choosen.
      if ($filetype=="ICS"){
         echo "<tr><td>File location ids</td><td><input type=\"file\" 
               name=\"locationids\" value=\"$locationids\"></td>\n";
      }
      // add metadata file upload
      echo "<tr><td>(optional) Additional image metadata file</td><td><input type=\"file\"
               name=\"metadata_file\"></td></tr>\n";





	// Check if status is that of an admin.
	if ($S_STATUS == $G_SUPER || $S_STATUS == $G_ADMIN)
	{
	    printUploadAsUser();
	}
	// End neat code by Frank Keijzers (SVI).




   }

   elseif ($uploadtype=="move") { 
      // read directory content and display to user 
      
      // let it be known who made the call
      echo "<INPUT TYPE ='hidden' NAME='uploadtype' VALUE='move'>\n";
      echo "<INPUT TYPE ='hidden' NAME='image_upload_directory' VALUE='$image_upload_directory'>\n";
      echo "<TABLE BORDER=\"0\">\n";

      // get directory information
//      $file=array();
      $realfile = array();

      if (file_exists($image_upload_directory) && is_dir( $image_upload_directory)){
        $darr=get_upload_dir();
        if (isset($darr[$image_upload_directory])){
            $fh=opendir($image_upload_directory);
            while($fn=readdir($fh)){
                $cond_a=is_file($image_upload_directory."/".$fn);
                $cond_b=($filetype=="ICS");
                $extension = strtolower (substr($fn,-3,3));
                $cond_c=($extension == "ics");
                $cond_d=is_readable($image_upload_directory."/".$fn);


                // if filetype=ICS, list only files with extension .ics
                // otherwise list all files.
                if ($cond_a && $cond_d && (!$cond_b || $cond_c))
                $realfile[]=$fn;
            }

        }	
      }
      if (count($realfile)>0) {
         if (!is_writable($image_upload_directory)) {
           echo"<font color=\"#ff0000\">";
           echo "<b>CAUTION:</b> The images listed below can be read, but 
           <b>the SIDB doesn't have permission to write</b> on this directory,
           so the files will not be deleted after transferring to the database.
           If this is not the behavior you want,
           please change the directory permissions before continuing 
           (recommended!)";
           echo"</font>";
         }
         echo "<H3>Enter the image metadata and select at least one file. <br>\n";
         // To protect the system, only allow multiple file uploads 
         // from 2-D files 
         //  if ($filetype == "2-D") {
            echo "Multiple files can be selected, but they should all 
                  be of the type '$filetype'\n";
            $multiple = "multiple";
         // } 
         show_image_form ($filetype, "new", $image_fields, $templateid);

         $size = count ($realfile) - $dirtest;
         if ($size>5) $size = 5;
         echo "<tr><td>Select file</td>\n";
         echo "<td><select $multiple size=\"$size\" name='file[]'>\n";
         for ($i=0; $i< count ($realfile); $i++) {
            //if (! (is_dir("$image_upload_directory/".$file[$i])) )
        
               echo "<option value=\"$realfile[$i]\">$realfile[$i]</option>\n";
         }
         echo "</select></td></tr>\n";




	    // Check if status is that of an admin.
	    if ($S_STATUS == $G_SUPER || $S_STATUS == $G_ADMIN)
	    {
		printUploadAsUser();
	    }
            else
	    {
		print("<input type=\"hidden\" name=\"upload_as_user\" ".
		      "value=\"$S_USERID\">");
	    }
	    // End neat code by Frank Keijzers (SVI).





	 echo "<tr><td>Also read metadata file?</td><td><INPUT TYPE=checkbox NAME=extra_metadata_file></td></tr>\n";
      }
      else {
         $dir = substr (strrchr ($image_upload_directory, "/"), 1);
         echo "</table></form>\n";
         if (is_readable($image_upload_directory)) 
            echo "<h3>No files. The selected image directory is empty, there are
           no images of the selected type, or the file permissions are not
           correct. First deposit a valid file in directory <i>'$dir'</i></h3>";
         else
            echo "<h3>You do not have permission to access directory $dir or it does not exist or can not be read</h3>";
         return false;
      }
   }

   if ($filetype == "other") {
      echo "<TR><TD>Provide an Image as Thumbnail</TD><TD>
            <INPUT TYPE=\"file\" NAME=\"location_thumb\" 
             VALUE=\"$location_thumb\"></TD>\n";
   }

   if ($filetype == "2-D" )  {
      // Checkbox to determine whether image comments should be imported, 
      // defaults to true
      $exists_import_array = array_keys($S_SETTINGS);
      if (in_array("import_comments", $exists_import_array) ) { 
         if ($S_SETTINGS["import_comments"])
            $checked = "checked";
         else
            $checked = "";
      }
      else {
         $checked = "checked";
      }
      echo "<TR><TD>Import image comments?</TD>
            <TD><INPUT TYPE=\"checkbox\" $checked NAME=\"import_comments\" 
                       VALUE=\"on\"></TD></TR>\n ";
   }

   echo "<TR><TD></TD><TD ALIGN=\"right\">
   When you click the upload button the file transfer will start: please <b>do not close</b> this browser window until it finishes.
         <INPUT TYPE=\"submit\" NAME=\"upload\" VALUE=\"upload file\" 
          onClick=\"return checkinput()\"></TD>\n";       
   echo "</TABLE>\n";
   echo "</FORM>";
}


////
// !function to physically write the file, first tries a move, when that fails 
// it copies
function upload_file() {
   global $filetype, $locationids_name, $location_name, $location, $locationids;
   global $imageid, $S_USERID,$S_STATUS,$G_SUPER,$G_ADMIN,$image_upload_directory,$upload_as_user,$uploadtype,$evansmode,$archive_dir;

   //echo "<!-- uploading file -->\n";
   $userid=$S_USERID;
   if ($S_STATUS ==$G_SUPER || $S_STATUS == $G_ADMIN) {
      $userid=$upload_as_user;
   }
   if (! $location_name) {
      $location_name = $location;
   }
   // echo "<!-- $location $imageid, $location_name -->\n";
   $path_file = get_image_location ($imageid, false, $location_name, $userid);
   $lastpartcommand = "'".$location."' '$path_file'";
   // echo "<!-- command $lastpartcommand -->\n";
    Debug::printDebug("type: ".$filetype);
   if ($filetype=="ICS") {
      system ("mv $lastpartcommand", $result);
      //rename($location, $path_file);
      if ($evansmode && $uploadtype=="move")
         `ln -s "$path_file" "$location"`;
      // when move fails, try a copy
      if(!file_exists($path_file))
         copy ($location, $path_file);
         //system ("cp $lastpartcommand");  
      
      // and now the ids file
      $path_file=get_image_location ($imageid, true, $location_name,$userid);
      Debug::printDebug("foute init path: $path_file");
      /* Of course it is a bad idea to get the IDS file from the location
       * of the ICS file with the function get_image_location!! That function
       * is getting the IDS file by replacing the ICS with a standard
       * IDS.GZ!!! You do not have the choice to upload a .ids
       * or .ids.gz!!! and the locationids_name is given to THIS function!!!
       * let's use it!!!
       * Greets, Frank
       */
      $path_file = "$archive_dir/$imageid"."_$locationids_name";
      Debug::printDebug("GOEIE??? init path: $path_file");
      // SAME HERE: $lastpartcommand=EscapeShellCmd ("$locationids $path_file");
      //$lastpartcommand = EscapeShellCmd ("'$locationids' '$path_file'");
      $lastpartcommand = "'".$locationids."' '".$path_file."'";
      Debug::printDebug($lastpartcommand);
      system ("mv $lastpartcommand", $result);
      //rename($locationids, $path_file);
      if ($evansmode)
         `ln -s "$path_file" "$locationids"`;
      //when move fails, try a copy
      if(!file_exists($path_file))
         //copy($locationids, $path_file);
         system ("cp $lastpartcommand");  
      
   }
   else {
      exec("mv $lastpartcommand", $result);
      //rename ($location, $path_file);
      if ($evansmode && $uploadtype=="move") {
        // echo "ln -s $path_file $location.<br>";
         `ln -s "$path_file" "$location"`;
      }
      //when move fails, try a copy
      if(!file_exists($path_file))
         copy($location, $path_file);
         //exec("cp $lastpartcommand",$result);
//      echo "<!-- $lastpartcommand ".implode("\n",$result)."-->\n";
   }
}

////
// !produce a javascript array for dynamic template listing
function make_js_array ($where_string) {

   global $S_USERID, $S_STATUS, $G_SUPER,$G_ADMIN,$upload_as_user;
   $userid=$S_USERID;
   if (($S_STATUS ==$G_SUPER || $S_STATUS == $G_ADMIN )&& isset($upload_as_user)) {
      $userid=$upload_as_user;
   }
   $db_query = "SELECT templateid,templatename FROM template WHERE 
                ($where_string) AND userid='$userid'";
   $db_result = db_exec($db_query);
   $db_numrows = db_NumRows ($db_result);
   if ($db_numrows) {
      $js_array = "   new Array(\n" ;
      $js_array .= "   new Array(\"No Template\", 0),\n";
      for ($i=0; $i < $db_numrows; $i++) {
         if ($i>0) 
            $js_array .= ",\n";
         $result = db_Fetch_array($db_result,$i);
         $name = $result["templatename"];
         $value = $result["templateid"];
         $js_array .= "      new Array(\"$name\",$value)";
      }
      $js_array .= "\n      )";
   }
   else
      $js_array .= "null";
   return $js_array;
}

////
// find_metadata_file will try to identify a metadata file in the 
// same directory as the original file

function find_metadata_file ($location) {
    global $image_upload_directory;
    // echo "<!-- METADATA $location -->\n";
    $filename=str_replace($image_upload_directory."/","",$location);
    $filename=strtolower($filename);
    $fileids=str_replace(".ics",".ids",$filename);
    $fileics=str_replace(".ids",".ics",$filename);
    $bits=explode('.',$filename);
//    $fileroot=substr($filename,0,strrchr($filename,"."));
      $fileroot=strtolower($bits[0]);
    $fh=opendir($image_upload_directory);
    $mdf="";

    while ($fn=readdir($fh)){
      $fn = strtolower($fn);
      $condition = ($fn != $filename &&  $fn != $fileids && 
              $fn != $fileics && strpos("A".$fn,$fileroot.".")==1);
      // echo "<!-- fn $fn ,$fileroot,".$condition."-->\n";
      if ($condition) {
          $mdf=$image_upload_directory."/".$fn;
      }
    }
    // echo "<!-- $mdf found $filename , $fileroot -->\n";
    return $mdf;	
	
}

/******************  main script starts here ******************************/

opendatabase();
// when showing the initial page we need to add some javascript statements
//if (!($next || $nextp || $upload ||$add || $channel_up || $channel_down) ) {
   $js_array = "modelinfo = new Array (\n"; 
   $js_array .= make_js_array ("filetype='2-D' OR filetype=NULL");   
   $js_array .= ",\n";
   $js_array .= make_js_array ("filetype='multipage' OR filetype=NULL");   
   $js_array .= ",\n";
   $js_array .= make_js_array ("filetype='3-D' OR filetype='ICS' OR filetype=NULL");   
   $js_array .= ",\n";
   $js_array .= make_js_array ("filetype='3-D' OR filetype='ICS' OR filetype=NULL");   
   $js_array .= ",\n";
   $js_array .= make_js_array ("filetype='other' OR filetype=NULL");   
   $js_array .= "\n);\n";
   printheader($js_array, "javascript/upload.js");

/* }
else
   printheader("javascript/upload.js");
*/
if (!($next || $nextp || $upload ||$add || $channel_up || $channel_down) ):
   // first save user's choices:
   $filetype=$S_SETTINGS["filetype"];
   $templateid=$S_SETTINGS["templateid"]; 
   $uploadtype=$S_SETTINGS["uploadtype"];
   $image_upload_directory=$S_SETTINGS["image_upload_directory"];
   set_user_settings ($S_USERID, $S_SETTINGS);
   //Show uploadform to upload a file
   printuploadform();

elseif ($next || $nextp):
   // first save user's choices:
   $S_SETTINGS["filetype"] = $filetype;
   $S_SETTINGS["templateid"] = $templateid;
   $S_SETTINGS["uploadtype"] = $uploadtype;
   $S_SETTINGS["image_upload_directory"] = $image_upload_directory;
   set_user_settings ($S_USERID, $S_SETTINGS);

   //Show uploadform to upload a file
   //echo "<H2>Upload your $filetype file here</H2>";
   printuploadform();

elseif($add):
   // first save user's choices:
   $S_SETTINGS["filetype"] = $filetype;
   $S_SETTINGS["templateid"] = $templateid;
   $S_SETTINGS["uploadtype"] = $uploadtype;
   set_user_settings ($S_USERID, $S_SETTINGS);

   if($templatename==""):
      $error_no_templatename = "Please choose a templatename";
   elseif(!(exist($templatename))):
      if (make_the_template (make_template_query(), $templatename, $keys)):
         $templateid = gettemplateid($templatename); 
         printuploadform();
      endif;
   else: 
      $error_double_templatename="This templatename exists already <BR> 
                                  please choose another name";
   endif;
elseif ($channel_up):
   printuploadform();

// if upload has taken place already (i.e. user pressed refresh/reload)
elseif ( ($upload) && 
         ($time_stamp == get_user_info($S_USERID, "last_action") )):
   if ($id = get_user_info($S_USERID, "last_image") ):
      $imageid = $id;
      include ("$include_dir/show_inc.php");
   endif;
     
// the real upload
elseif($upload):
   $dups=array();
   $userid=$S_USERID;
   if ($S_STATUS < $G_USER)
      echo "<h3>Sorry, guests may not upload files</h3><br>";
   else {
      if (isset($upload_as_user) && ($S_STATUS ==$G_SUPER ||$S_STATUS == $G_ADMIN) && $upload_as_user != $S_USERID && valid_user($upload_as_user) ) 
	 $userid=$upload_as_user; 	
      if ($import_comments) 
         $S_SETTINGS["import_comments"] = true;
      else 
         $S_SETTINGS["import_comments"] = false;
      set_user_settings ($S_USERID, $S_SETTINGS);
 
      $size = diskfreespace($archive_dir);
   
   if ($uploadtype == "html"): 
      $image_upload_directory=getenv("TMPDIR");
      // Check if a file is selected.
      if ($location==""):
         $error = "Please provide a filename!";
      elseif($location=="none" ):
         $error = "Something went wrong during the upload; try again.";
      // check if ids file is entered when an ics is gonna be uploaded
      elseif ($filetype == "ics" && ($locationids=="" || $locationids=="none")):
         $error = "Please give 'ids' file location!";
      //check for current available disk space...
      elseif (( $size <= @filesize($location)) || 
              ($size <= @filesize($locationids)) ):
         $error = "Not enough space for upload to complete...
                  <br>There is".$size." diskspace available on disk, which
                  is not enough for this operation";

      /* everything OK, so do the upload
       *
       * I will continue the work here. - Frank (SVI)
       *
       * The way it is done now, images are first put
       * into the database, then a thumbnail is made.
       * The thing is though, if a template is 
       * selected, the information in the template
       * will be stored into the database to the 
       * image. A good thing, put people should have
       * a choice to completely override all image 
       * settings, or use the template to complete
       * the empty fields with values from the
       * template. (As can be the case just the
       * other way around as well!)
       *
       * The way I want to have it work:
       *
       * After a succesfull upload of the image, get
       * all its infor on parameters and stuff, from
       * the image itself. After that, see if we use
       * a template and in what way to use it. To
       * make it easy on ourselves, we are going to
       * use the new Image class object to neatly get
       * info from the image.
       */

      else:
      
         if (@filesize($locationids)>$filesize):
            $filesize = filesize($locationids);
         endif;
	 $thismd5=false;
         // location is known, so do the upload
         if (upload_database()) {
            upload_file();
	    $dupimg=false;
	    $marr=match_image_md5($thismd5);
	    for (reset($marr);list($iid,$iown)=each($marr);){
		if ($iid != $imageid){
		      $iname=get_image_info($iid,"filename");
		      $ilink="<a href=$http_method://$sidb_root/show.php?id=$iid>";
		      $dupimg="Possible duplicate image with $ilink $iname ($iid) </a>owned by $iown";
		}
	    }
            $path_file = get_image_location($imageid, false, $location_name, $S_USERID); 
            if(!file_exists($path_file))
               $error_uploadfile = "Connection failed: please try again. $imageid $location_name";
            else {
               // create the thumbnails
               if($filetype=="ICS"||$filetype=="3-D")
	       {
		  Debug::printDebug("location ics: $location_name");
		  Debug::printDebug("location ids: $locationids_name");
		  // if .ics image, uncompressedits .ids!
                  $filesize=compressids($imageid, $locationids_name);
                  upload_database(true);
                  // create the thumbnail
                  huygens_thumbnail($location_name, $imageid, true);
	       }
               elseif ($filetype=="other") {
                  if ($location_thumb && $location_thumb <> "none") {
                     if (!is_uploaded ($location_thumb)) {
                        echo "Possible file upload attack. 
                              Filename: $location_thumb.<br>";
                        return false;
                     }
                     import_thumbnail($location_thumb, $imageid);
                  }
               }
               elseif ($filetype=="2-D") {
                  other_thumbnail($location_name, $imageid);
                  // import image comments.  Use iptcutils, or else buld in functions
		  if ($imageinfo_path && $import_comments)
		     get_image_comments($imageid);
                  elseif ($import_comments)
                     get_iptc_comments ($location_name, $imageid);
		  if ($metadata_file) {
		      get_external_metadata($metadata_file,$imageid);
		  }
               }
               elseif ($filetype=="multipage") {
                  other_thumbnail($location_name, $imageid);
                  if ($import_comments)
                     get_iptc_comments ($location_name, $imageid);
		  if ($imageinfo_path && $import_comments)
		     get_image_comments($imageid);
		  if ($metadata_file) {
		      get_external_metadata($metadata_file,$imageid);
		  }
               }
               // and show the image with metadata
               echo "<H3>Your file has been uploaded to the server!</H3>";

	        // send email notification on successful upload.
		$imagelink = "http://$sidb_root/show.php?id=$imageid";
		$email = new Email($imagelink);

	       // whats dis? - AAAH, IF DUPLICATEIMAGE!
	       if ($dupimg)
		  echo "<font color=#FF0000>".$dupimg."</font><br>\n"; 
               $id = $imageid;
               echo "<TABLE>";
               include ("$include_dir/show_inc.php");
               echo "</TABLE>\n";
            }
         }
         else
            echo "Error while uploading data to the database.<br>";
      endif;
     
   elseif ($uploadtype == "move"):
      if (sizeof($file) == 0)
         $error = "Please select at least one file!";
      else {
      $duparr=array();
         for ($i = 0; $i < sizeof ($file); $i++) {
            // in case of ics files some parameters need to be set
            if ($filetype=="ICS") :
               // first determine if we have the ics or ids
               $extension = strtolower (substr($file[$i],-3,3));
               // now get the right files into the right variables
               if ($extension == "ics"):
                  $location_name = $file[$i];
                  $location = $image_upload_directory."/".$file[$i];
                  $locationids_name = 
                        substr_replace($file[$i], ".ids", strlen($file[$i])-4);
                  $locationids = $image_upload_directory."/".$locationids_name;
                  // maybe the file is gzipped!
		  if(!file_exists($locationids)) {
		     $locationids_name =
                     substr_replace($file[$i], ".ids.gz", strlen($file[$i])-4);
		   $locationids = $image_upload_directory."/".$locationids_name;
                   Debug::printDebug("looking for ids.gz: $locationids");
                  }
               endif;
               if ($extension == "ids"):
                  $locationids_name = $file[$i];
                  $locationids = $image_upload_directory."/".$file[$i];
                  $location_name = 
                        substr_replace($file[$i], ".ics", strlen($file[$i])-4);
                  $location = $image_upload_directory."/".$location_name;
               endif;
               $filesize = filesize($locationids) + filesize($location);
            else:  //the easy case
               $location_name = $file[$i]; 
               $location = $image_upload_directory."/".$file[$i];
               $filesize = filesize($location);
            endif;

            if ($file[$i]==""):
               $error = "Please select a file!";
            elseif ($size <= $filesize):
               $error = "Not enough space for upload to complete...
                     <br>There is".$size." diskspace available on disk, which
                    is not enough for this operation";
            else:
               // be sure that imageid is unset for multiple file uploads
               $imageid=false;
               // there is a filename and enough space
               if (upload_database() ) {
                  upload_file();
                  if ($filesize<$max_md5_filesize) {
                     $marr=match_image_md5($thismd5);
		     for (reset($marr);list($iid,$iown)=each($marr);){
		        if ($iid != $imageid){
		           $iname=get_image_info($iid,"filename");
		           $ilink="<a href=$http_method://$sidb_root/show.php?id=$iid>";
		           $duparr[]="Possible duplicate image with $ilink $iname ($iid) </a>owned by $iown";
			}
		     }
                  } 
      
                  // check whether file is in archive.  
                  // if so, try to delete the original
                  $path_file = get_image_location($imageid, false, $location_name, $S_USERID); 
                  if(!file_exists($path_file))
                     $error_uploadfile = "Connection failed: please try again.";
                  else {  

                     // create the thumbnails
                     if($filetype=="ICS"||$filetype=="3-D")
                     {
                        Debug::printDebug("location ics: $location_name");
                        Debug::printDebug("location ids: $locationids_name");
                        // if .ics image, uncompressedits .ids!
                        $filesize=compressids($imageid, $locationids_name);
                        upload_database(true);
                        huygens_thumbnail($location_name, $imageid, true);
                     }
                     elseif ($filetype=="other") {
                     if ($location_thumb && $location_thumb <> "none") {
                           if (!is_uploaded ($location_thumb)) {
                              echo "Possible file upload attack. 
                                    Filename: $location_thumb.<br>";
                              return false;
                           }
                           import_thumbnail($location_thumb, $imageid);
                        }
                     }
                     elseif ($filetype=="2-D") {
                        other_thumbnail($location_name, $imageid);
                        if ($import_comments)
                           get_iptc_comments ($location_name, $imageid);
                        if ($imageinfo_path && $import_comments)
		           get_image_comments($imageid);
                        echo "<!-- $imageinfo_path $imageid $import_comments -->\n";
                        //if ($extra_metadata_file) {
		           //$mdf=find_metadata_file($location);
		        //if ($mdf)	
		           //get_external_metadata($mdf,$imageid);
                        //}
                     }
                     elseif ($filetype=="multipage") {
                        other_thumbnail($location_name, $imageid);
                        if ($import_comments)
                           get_iptc_comments ($location_name, $imageid);
		        if ($imageinfo_path && $import_comments)
		           get_image_comments($imageid);
		        //if ($extra_metadata_file) {
		           //$mdf=find_metadata_file($location);
		           //if ($mdf)	
	         	      //get_external_metadata($mdf,$imageid);
		        //}
                     }
                        if ($extra_metadata_file) {
		           $mdf=find_metadata_file($location);
		        if ($mdf)	
		           get_external_metadata($mdf,$imageid);
                   }
                     // and show the image with metadataa
                     if (sizeof($file) == 1 ) {
                        echo "<H3>Your file has been uploaded to the server!
                              </H3>";

			// send email notification on successful upload.
			$imagelink = "http://$sidb_root/show.php?id=$imageid";
			$email = new Email($imagelink);

/* seems to create duplicate upload screens
			if (count($duparr)>0)
			   echo "<font color=#FF0000>".implode($duparr,"<br>\n")."</font><br>\n"; 
                        $id = $imageid;
                        echo "<TABLE>\n";
                        include ("$include_dir/show_inc.php");
                        echo "</TABLE>\n"; 
*/
                     } 
                  }
               } 
            endif;

         } // for loop
      
         // lets assume the multiple file upload succeeded and give 
         // the happy news to the user
         $uploaded_files = sizeof($file);
         if ($uploaded_files > 1)
            echo "<h3>Tried uploading $uploaded_files images into the database ".
                  "and apparently succeeded. <br>Press 'My Images' to see ". 
                  "the other images.</h3>\n";
          if (count($duparr)>0)
		   echo "<font color=#FF0000>".implode($duparr,"<br>\n")."</font><br>\n"; 
            $id = $imageid;
            echo "<TABLE>\n";
            include ("$include_dir/show_inc.php");
            echo "</TABLE>\n"; 

         } // end of sizeof ($file) > 0 

      endif; //$uploadtype == html  

   } //if ($S_USERID >= $G_USER)

endif;
   
// If something went wrong, a new input screen will be shown.
if ($error_no_templatename):
   echo "<H2>".$error_no_templatename."</H2>";
   show_new_template_form($filetype, $uploadtype);
elseif($error_double_templatename):
   echo "<H2>".$error_double_templatename."</H2>";
   show_new_template_form($filetype, $uploadtype);
elseif($error_uploadfile):
   //delete_file();
   echo "<H2>".$error_uploadfile."</H2>";
   printuploadform();
elseif($error_filetype):
   echo "<H2>".$error_filetype ."</H2>";
   show_new_template_form ($filetype, $uploadtype);
elseif ($error):
   echo "<H2>".$error ."</H2>";
   printuploadform();
endif;


printfooter();
?>
